"""
    Controller API

    Controller description  # noqa: E501

    The version of the OpenAPI document: 6.x.x
    Contact: support@spacevm.ru
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401
from typing import List, Dict

from spacevm_controller_client.api_client import ApiClient, Endpoint as _Endpoint
from spacevm_controller_client.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from spacevm_controller_client.model.char import Char
from spacevm_controller_client.model.snmp_config import SnmpConfig
from spacevm_controller_client.model.snmp_config_delete import SnmpConfigDelete
from spacevm_controller_client.model.swagger_snmp_configuration import SwaggerSnmpConfiguration
from spacevm_controller_client.model.swagger_snmp_walk_response import SwaggerSnmpWalkResponse


class SnmpApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.api_controllers_get_snmp_configuration_retrieve_endpoint = _Endpoint(
            settings={
                'response_type': (SwaggerSnmpConfiguration,),
                'auth': [
                    'jwtAuth'
                ],
                'endpoint_path': '/api/controllers/get-snmp-configuration/',
                'operation_id': 'api_controllers_get_snmp_configuration_retrieve',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                },
                'attribute_map': {
                },
                'location_map': {
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.api_controllers_remove_snmp_configuration_create_endpoint = _Endpoint(
            settings={
                'response_type': (Char,),
                'auth': [
                    'jwtAuth'
                ],
                'endpoint_path': '/api/controllers/remove-snmp-configuration/',
                'operation_id': 'api_controllers_remove_snmp_configuration_create',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'snmp_config_delete',
                ],
                'required': [
                    'snmp_config_delete',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'snmp_config_delete':
                        (SnmpConfigDelete,),
                },
                'attribute_map': {
                },
                'location_map': {
                    'snmp_config_delete': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json',
                    'application/x-www-form-urlencoded',
                    'multipart/form-data'
                ]
            },
            api_client=api_client
        )
        self.api_controllers_snmp_walk_retrieve_endpoint = _Endpoint(
            settings={
                'response_type': (SwaggerSnmpWalkResponse,),
                'auth': [
                    'jwtAuth'
                ],
                'endpoint_path': '/api/controllers/snmp-walk/',
                'operation_id': 'api_controllers_snmp_walk_retrieve',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'ip',
                    'version',
                    'cmd_type',
                    'command',
                ],
                'required': [
                    'ip',
                    'version',
                ],
                'nullable': [
                ],
                'enum': [
                    'version',
                    'cmd_type',
                ],
                'validation': [
                    'ip',
                    'version',
                    'cmd_type',
                    'command',
                ]
            },
            root_map={
                'validations': {
                    ('ip',): {

                        'min_length': 1,
                    },
                    ('version',): {

                        'min_length': 1,
                    },
                    ('cmd_type',): {

                        'min_length': 1,
                    },
                    ('command',): {
                        'max_length': 255,
                        'min_length': 1,
                    },
                },
                'allowed_values': {
                    ('version',): {

                        "2C": "2c",
                        "1": "1",
                        "3": "3"
                    },
                    ('cmd_type',): {

                        "SNMPWALK": "snmpwalk",
                        "SNMPTABLE": "snmptable"
                    },
                },
                'openapi_types': {
                    'ip':
                        (str,),
                    'version':
                        (str,),
                    'cmd_type':
                        (str,),
                    'command':
                        (str,),
                },
                'attribute_map': {
                    'ip': 'ip',
                    'version': 'version',
                    'cmd_type': 'cmd_type',
                    'command': 'command',
                },
                'location_map': {
                    'ip': 'query',
                    'version': 'query',
                    'cmd_type': 'query',
                    'command': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.api_controllers_update_snmp_configuration_update_endpoint = _Endpoint(
            settings={
                'response_type': (Char,),
                'auth': [
                    'jwtAuth'
                ],
                'endpoint_path': '/api/controllers/update-snmp-configuration/',
                'operation_id': 'api_controllers_update_snmp_configuration_update',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'snmp_config',
                ],
                'required': [
                    'snmp_config',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'snmp_config':
                        (SnmpConfig,),
                },
                'attribute_map': {
                },
                'location_map': {
                    'snmp_config': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json',
                    'application/x-www-form-urlencoded',
                    'multipart/form-data'
                ]
            },
            api_client=api_client
        )

    def api_controllers_get_snmp_configuration_retrieve(
        self,
        **kwargs
    ):
        """api_controllers_get_snmp_configuration_retrieve  # noqa: E501

        Получает словарь настроек snmp c контроллера  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.api_controllers_get_snmp_configuration_retrieve(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            SwaggerSnmpConfiguration
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        return self.api_controllers_get_snmp_configuration_retrieve_endpoint.call_with_http_info(**kwargs)

    def api_controllers_remove_snmp_configuration_create(
        self,
        snmp_config_delete,
        **kwargs
    ):
        """api_controllers_remove_snmp_configuration_create  # noqa: E501

        Удаляет словарь правил в yaml на контроллере.                                                Используется только для подготовки тестового окружения.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.api_controllers_remove_snmp_configuration_create(snmp_config_delete, async_req=True)
        >>> result = thread.get()

        Args:
            snmp_config_delete (SnmpConfigDelete):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            Char
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['snmp_config_delete'] = \
            snmp_config_delete
        return self.api_controllers_remove_snmp_configuration_create_endpoint.call_with_http_info(**kwargs)

    def api_controllers_snmp_walk_retrieve(
        self,
        ip,
        version,
        **kwargs
    ):
        """api_controllers_snmp_walk_retrieve  # noqa: E501

        Эндпоинт для запуска snmpwalk на заданном узле.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.api_controllers_snmp_walk_retrieve(ip, version, async_req=True)
        >>> result = thread.get()

        Args:
            ip (str):
            version (str):

        Keyword Args:
            cmd_type (str): [optional] if omitted the server will use the default value of "snmpwalk"
            command (str): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            SwaggerSnmpWalkResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['ip'] = \
            ip
        kwargs['version'] = \
            version
        return self.api_controllers_snmp_walk_retrieve_endpoint.call_with_http_info(**kwargs)

    def api_controllers_update_snmp_configuration_update(
        self,
        snmp_config,
        **kwargs
    ):
        """api_controllers_update_snmp_configuration_update  # noqa: E501

        Пишет словарь правил в yaml на контроллер.                                                Отправляет в очередь Redis сообщение о статусе сервиса snmpd.                                                Сохраняет настройки snmp в базу.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.api_controllers_update_snmp_configuration_update(snmp_config, async_req=True)
        >>> result = thread.get()

        Args:
            snmp_config (SnmpConfig):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            _request_auths (list): set to override the auth_settings for an a single
                request; this effectively ignores the authentication
                in the spec for a single request.
                Default is None
            async_req (bool): execute request asynchronously

        Returns:
            Char
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['_request_auths'] = kwargs.get('_request_auths', None)
        kwargs['snmp_config'] = \
            snmp_config
        return self.api_controllers_update_snmp_configuration_update_endpoint.call_with_http_info(**kwargs)

