"""
    Controller API

    Controller description  # noqa: E501

    The version of the OpenAPI document: 6.x.x
    Contact: support@spacevm.ru
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401
from typing import List, Dict

from spacevm_controller_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from spacevm_controller_client.exceptions import ApiAttributeError


def lazy_import():
    from spacevm_controller_client.model.connection_type_c4e_enum import ConnectionTypeC4eEnum
    from spacevm_controller_client.model.directory_type_enum import DirectoryTypeEnum
    globals()['ConnectionTypeC4eEnum'] = ConnectionTypeC4eEnum
    globals()['DirectoryTypeEnum'] = DirectoryTypeEnum


class AuthenticationDirectoryCreate(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('directory_url',): {
            'max_length': 255,
        },
        ('service_username',): {
            'max_length': 150,
        },
        ('verbose_name',): {
            'max_length': 255,
        },
        ('service_password',): {
            'max_length': 128,
        },
        ('domain_name',): {
            'max_length': 255,
        },
        ('secret',): {
            'max_length': 255,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'connection_type': (ConnectionTypeC4eEnum,),  # noqa: E501
            'created': (datetime,),  # noqa: E501
            'directory_type': (DirectoryTypeEnum,),  # noqa: E501
            'directory_url': (str,),  # noqa: E501
            'subdomain_name': (str,),  # noqa: E501
            'entity_type': (str,),  # noqa: E501
            'id': (str,),  # noqa: E501
            'locked_by': (str, none_type,),  # noqa: E501
            'modified': (datetime,),  # noqa: E501
            'service_username': (str,),  # noqa: E501
            'status': (str,),  # noqa: E501
            'verbose_name': (str,),  # noqa: E501
            'sso': (bool,),  # noqa: E501
            'admin_server': (str, none_type,),  # noqa: E501
            'kdc_urls': ([str], none_type,),  # noqa: E501
            'service_password': (str,),  # noqa: E501
            'description': (str,),  # noqa: E501
            'domain_name': (str,),  # noqa: E501
            'nomap_role': (int, none_type,),  # noqa: E501
            'secret': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'connection_type': 'connection_type',  # noqa: E501
        'created': 'created',  # noqa: E501
        'directory_type': 'directory_type',  # noqa: E501
        'directory_url': 'directory_url',  # noqa: E501
        'subdomain_name': 'subdomain_name',  # noqa: E501
        'entity_type': 'entity_type',  # noqa: E501
        'id': 'id',  # noqa: E501
        'locked_by': 'locked_by',  # noqa: E501
        'modified': 'modified',  # noqa: E501
        'service_username': 'service_username',  # noqa: E501
        'status': 'status',  # noqa: E501
        'verbose_name': 'verbose_name',  # noqa: E501
        'sso': 'sso',  # noqa: E501
        'admin_server': 'admin_server',  # noqa: E501
        'kdc_urls': 'kdc_urls',  # noqa: E501
        'service_password': 'service_password',  # noqa: E501
        'description': 'description',  # noqa: E501
        'domain_name': 'domain_name',  # noqa: E501
        'nomap_role': 'nomap_role',  # noqa: E501
        'secret': 'secret',  # noqa: E501
    }

    read_only_vars = {
        'created',  # noqa: E501
        'subdomain_name',  # noqa: E501
        'entity_type',  # noqa: E501
        'id',  # noqa: E501
        'locked_by',  # noqa: E501
        'modified',  # noqa: E501
        'status',  # noqa: E501
        'sso',  # noqa: E501
        'admin_server',  # noqa: E501
        'kdc_urls',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, connection_type, created, directory_type, directory_url, subdomain_name, entity_type, id, locked_by, modified, service_username, status, verbose_name, sso, admin_server, kdc_urls, service_password, *args, **kwargs):  # noqa: E501
        """AuthenticationDirectoryCreate - a model defined in OpenAPI

        Args:
            connection_type (ConnectionTypeC4eEnum):
            created (datetime):
            directory_type (DirectoryTypeEnum):
            directory_url (str):
            subdomain_name (str):
            entity_type (str):
            id (str):
            locked_by (str, none_type):
            modified (datetime):
            service_username (str):
            status (str):
            verbose_name (str):
            sso (bool):
            admin_server (str, none_type):
            kdc_urls ([str], none_type):
            service_password (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            description (str): Краткое описание экземпляра.. [optional]  # noqa: E501
            domain_name (str): [optional]  # noqa: E501
            nomap_role (int, none_type): [optional]  # noqa: E501
            secret (str): RADIUS secret.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.connection_type = connection_type
        self.created = created
        self.directory_type = directory_type
        self.directory_url = directory_url
        self.subdomain_name = subdomain_name
        self.entity_type = entity_type
        self.id = id
        self.locked_by = locked_by
        self.modified = modified
        self.service_username = service_username
        self.status = status
        self.verbose_name = verbose_name
        self.sso = sso
        self.admin_server = admin_server
        self.kdc_urls = kdc_urls
        self.service_password = service_password
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, connection_type, directory_type, directory_url, service_username, verbose_name, service_password, *args, **kwargs):  # noqa: E501
        """AuthenticationDirectoryCreate - a model defined in OpenAPI

        Args:
            connection_type (ConnectionTypeC4eEnum):
            directory_type (DirectoryTypeEnum):
            directory_url (str):
            service_username (str):
            verbose_name (str):
            service_password (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            description (str): Краткое описание экземпляра.. [optional]  # noqa: E501
            domain_name (str): [optional]  # noqa: E501
            nomap_role (int, none_type): [optional]  # noqa: E501
            secret (str): RADIUS secret.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.connection_type = connection_type
        self.directory_type = directory_type
        self.directory_url = directory_url
        self.service_username = service_username
        self.verbose_name = verbose_name
        self.service_password = service_password
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
