"""
    Controller API

    Controller description  # noqa: E501

    The version of the OpenAPI document: 6.x.x
    Contact: support@spacevm.ru
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401
from typing import List, Dict

from spacevm_controller_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from spacevm_controller_client.exceptions import ApiAttributeError


def lazy_import():
    from spacevm_controller_client.model.name_node import NameNode
    globals()['NameNode'] = NameNode


class ClusterUpdate(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('verbose_name',): {
            'max_length': 255,
        },
        ('description',): {
            'max_length': 255,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'cpu_count': (int,),  # noqa: E501
            'created': (datetime,),  # noqa: E501
            'datacenter': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'optimal_cpu_model': (str,),  # noqa: E501
            'id': (str,),  # noqa: E501
            'locked_by': (str, none_type,),  # noqa: E501
            'memory_count': (int,),  # noqa: E501
            'modified': (datetime,),  # noqa: E501
            'nodes': ([NameNode],),  # noqa: E501
            'fencing_type': (str,),  # noqa: E501
            'heartbeat_type': (str,),  # noqa: E501
            'permissions': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'status': (str,),  # noqa: E501
            'verbose_name': (str,),  # noqa: E501
            'built_in': (bool,),  # noqa: E501
            'hints': (int,),  # noqa: E501
            'tags': ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}],),  # noqa: E501
            'entity_type': (str,),  # noqa: E501
            'cpu_used_percent_user': (int,),  # noqa: E501
            'mem_used_percent_user': (int,),  # noqa: E501
            'ha_autoselect': (bool,),  # noqa: E501
            'ha_enabled': (bool,),  # noqa: E501
            'ha_nodepolicy': ([str],),  # noqa: E501
            'ha_retrycount': (int,),  # noqa: E501
            'ha_timeout': (int,),  # noqa: E501
            'ha_boot_delay': (int,),  # noqa: E501
            'ha_boot_agent': (int,),  # noqa: E501
            'drs_check_timeout': (int,),  # noqa: E501
            'drs_enabled': (bool,),  # noqa: E501
            'drs_metrics_strategy': (str,),  # noqa: E501
            'drs_mode': (str,),  # noqa: E501
            'drs_node_settings': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'drs_strategy': (str,),  # noqa: E501
            'drs_deviation_limit': (float,),  # noqa: E501
            'tag_enabled': (bool,),  # noqa: E501
            'anti_affinity_enabled': (bool,),  # noqa: E501
            'tag_mode': (str,),  # noqa: E501
            'quorum': (bool,),  # noqa: E501
            'options': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'description': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'cpu_count': 'cpu_count',  # noqa: E501
        'created': 'created',  # noqa: E501
        'datacenter': 'datacenter',  # noqa: E501
        'optimal_cpu_model': 'optimal_cpu_model',  # noqa: E501
        'id': 'id',  # noqa: E501
        'locked_by': 'locked_by',  # noqa: E501
        'memory_count': 'memory_count',  # noqa: E501
        'modified': 'modified',  # noqa: E501
        'nodes': 'nodes',  # noqa: E501
        'fencing_type': 'fencing_type',  # noqa: E501
        'heartbeat_type': 'heartbeat_type',  # noqa: E501
        'permissions': 'permissions',  # noqa: E501
        'status': 'status',  # noqa: E501
        'verbose_name': 'verbose_name',  # noqa: E501
        'built_in': 'built_in',  # noqa: E501
        'hints': 'hints',  # noqa: E501
        'tags': 'tags',  # noqa: E501
        'entity_type': 'entity_type',  # noqa: E501
        'cpu_used_percent_user': 'cpu_used_percent_user',  # noqa: E501
        'mem_used_percent_user': 'mem_used_percent_user',  # noqa: E501
        'ha_autoselect': 'ha_autoselect',  # noqa: E501
        'ha_enabled': 'ha_enabled',  # noqa: E501
        'ha_nodepolicy': 'ha_nodepolicy',  # noqa: E501
        'ha_retrycount': 'ha_retrycount',  # noqa: E501
        'ha_timeout': 'ha_timeout',  # noqa: E501
        'ha_boot_delay': 'ha_boot_delay',  # noqa: E501
        'ha_boot_agent': 'ha_boot_agent',  # noqa: E501
        'drs_check_timeout': 'drs_check_timeout',  # noqa: E501
        'drs_enabled': 'drs_enabled',  # noqa: E501
        'drs_metrics_strategy': 'drs_metrics_strategy',  # noqa: E501
        'drs_mode': 'drs_mode',  # noqa: E501
        'drs_node_settings': 'drs_node_settings',  # noqa: E501
        'drs_strategy': 'drs_strategy',  # noqa: E501
        'drs_deviation_limit': 'drs_deviation_limit',  # noqa: E501
        'tag_enabled': 'tag_enabled',  # noqa: E501
        'anti_affinity_enabled': 'anti_affinity_enabled',  # noqa: E501
        'tag_mode': 'tag_mode',  # noqa: E501
        'quorum': 'quorum',  # noqa: E501
        'options': 'options',  # noqa: E501
        'description': 'description',  # noqa: E501
    }

    read_only_vars = {
        'cpu_count',  # noqa: E501
        'created',  # noqa: E501
        'datacenter',  # noqa: E501
        'optimal_cpu_model',  # noqa: E501
        'id',  # noqa: E501
        'locked_by',  # noqa: E501
        'memory_count',  # noqa: E501
        'modified',  # noqa: E501
        'fencing_type',  # noqa: E501
        'heartbeat_type',  # noqa: E501
        'permissions',  # noqa: E501
        'status',  # noqa: E501
        'built_in',  # noqa: E501
        'hints',  # noqa: E501
        'tags',  # noqa: E501
        'entity_type',  # noqa: E501
        'cpu_used_percent_user',  # noqa: E501
        'mem_used_percent_user',  # noqa: E501
        'ha_autoselect',  # noqa: E501
        'ha_enabled',  # noqa: E501
        'ha_nodepolicy',  # noqa: E501
        'ha_retrycount',  # noqa: E501
        'ha_timeout',  # noqa: E501
        'ha_boot_delay',  # noqa: E501
        'ha_boot_agent',  # noqa: E501
        'drs_check_timeout',  # noqa: E501
        'drs_enabled',  # noqa: E501
        'drs_metrics_strategy',  # noqa: E501
        'drs_mode',  # noqa: E501
        'drs_node_settings',  # noqa: E501
        'drs_strategy',  # noqa: E501
        'drs_deviation_limit',  # noqa: E501
        'tag_enabled',  # noqa: E501
        'anti_affinity_enabled',  # noqa: E501
        'tag_mode',  # noqa: E501
        'quorum',  # noqa: E501
        'options',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, cpu_count, created, datacenter, optimal_cpu_model, id, locked_by, memory_count, modified, nodes, fencing_type, heartbeat_type, permissions, status, verbose_name, built_in, hints, tags, entity_type, cpu_used_percent_user, mem_used_percent_user, ha_autoselect, ha_enabled, ha_nodepolicy, ha_retrycount, ha_timeout, ha_boot_delay, ha_boot_agent, drs_check_timeout, drs_enabled, drs_metrics_strategy, drs_mode, drs_node_settings, drs_strategy, drs_deviation_limit, tag_enabled, anti_affinity_enabled, tag_mode, quorum, options, *args, **kwargs):  # noqa: E501
        """ClusterUpdate - a model defined in OpenAPI

        Args:
            cpu_count (int):
            created (datetime):
            datacenter (bool, date, datetime, dict, float, int, list, str, none_type):
            optimal_cpu_model (str):
            id (str):
            locked_by (str, none_type):
            memory_count (int):
            modified (datetime):
            nodes ([NameNode]):
            fencing_type (str):
            heartbeat_type (str):
            permissions (bool, date, datetime, dict, float, int, list, str, none_type): Список разрешенных действий с моделью для текущего пользователя.
            status (str):
            verbose_name (str):
            built_in (bool):
            hints (int):
            tags ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]):
            entity_type (str):
            cpu_used_percent_user (int):
            mem_used_percent_user (int):
            ha_autoselect (bool):
            ha_enabled (bool):
            ha_nodepolicy ([str]):
            ha_retrycount (int):
            ha_timeout (int):
            ha_boot_delay (int):
            ha_boot_agent (int):
            drs_check_timeout (int):
            drs_enabled (bool):
            drs_metrics_strategy (str):
            drs_mode (str):
            drs_node_settings ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            drs_strategy (str):
            drs_deviation_limit (float):
            tag_enabled (bool):
            anti_affinity_enabled (bool):
            tag_mode (str):
            quorum (bool):
            options ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            description (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.cpu_count = cpu_count
        self.created = created
        self.datacenter = datacenter
        self.optimal_cpu_model = optimal_cpu_model
        self.id = id
        self.locked_by = locked_by
        self.memory_count = memory_count
        self.modified = modified
        self.nodes = nodes
        self.fencing_type = fencing_type
        self.heartbeat_type = heartbeat_type
        self.permissions = permissions
        self.status = status
        self.verbose_name = verbose_name
        self.built_in = built_in
        self.hints = hints
        self.tags = tags
        self.entity_type = entity_type
        self.cpu_used_percent_user = cpu_used_percent_user
        self.mem_used_percent_user = mem_used_percent_user
        self.ha_autoselect = ha_autoselect
        self.ha_enabled = ha_enabled
        self.ha_nodepolicy = ha_nodepolicy
        self.ha_retrycount = ha_retrycount
        self.ha_timeout = ha_timeout
        self.ha_boot_delay = ha_boot_delay
        self.ha_boot_agent = ha_boot_agent
        self.drs_check_timeout = drs_check_timeout
        self.drs_enabled = drs_enabled
        self.drs_metrics_strategy = drs_metrics_strategy
        self.drs_mode = drs_mode
        self.drs_node_settings = drs_node_settings
        self.drs_strategy = drs_strategy
        self.drs_deviation_limit = drs_deviation_limit
        self.tag_enabled = tag_enabled
        self.anti_affinity_enabled = anti_affinity_enabled
        self.tag_mode = tag_mode
        self.quorum = quorum
        self.options = options
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, nodes, verbose_name, *args, **kwargs):  # noqa: E501
        """ClusterUpdate - a model defined in OpenAPI

            nodes ([NameNode]):
            verbose_name (str):
        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            description (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.nodes = nodes
        self.verbose_name = verbose_name
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
