"""
    Controller API

    Controller description  # noqa: E501

    The version of the OpenAPI document: 6.x.x
    Contact: support@spacevm.ru
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401
from typing import List, Dict

from spacevm_controller_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from spacevm_controller_client.exceptions import ApiAttributeError


def lazy_import():
    from spacevm_controller_client.model.cloud_config import CloudConfig
    from spacevm_controller_client.model.update_resources import UpdateResources
    from spacevm_controller_client.model.v_machine_inf_soft_create import VMachineInfSoftCreate
    globals()['CloudConfig'] = CloudConfig
    globals()['UpdateResources'] = UpdateResources
    globals()['VMachineInfSoftCreate'] = VMachineInfSoftCreate


class DomainClone(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('verbose_name',): {
            'max_length': 255,
        },
        ('count',): {
            'inclusive_minimum': 1,
        },
        ('memory_count',): {
            'inclusive_minimum': 50,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'idempotency_key': (str,),  # noqa: E501
            'node': (str,),  # noqa: E501
            'resource_pool': (str,),  # noqa: E501
            'verbose_name': (str,),  # noqa: E501
            'datapool': (str,),  # noqa: E501
            'snapshot': (str,),  # noqa: E501
            'count': (int,),  # noqa: E501
            'domains_ids': ([str],),  # noqa: E501
            'start_on': (bool,),  # noqa: E501
            'template': (bool,),  # noqa: E501
            'replication': (bool,),  # noqa: E501
            'cloud_init': (bool,),  # noqa: E501
            'cloud_init_config': (CloudConfig,),  # noqa: E501
            'memory_count': (int,),  # noqa: E501
            'cpu_topology': ([UpdateResources],),  # noqa: E501
            'vmachine_infs': ([VMachineInfSoftCreate],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'idempotency_key': 'idempotency_key',  # noqa: E501
        'node': 'node',  # noqa: E501
        'resource_pool': 'resource_pool',  # noqa: E501
        'verbose_name': 'verbose_name',  # noqa: E501
        'datapool': 'datapool',  # noqa: E501
        'snapshot': 'snapshot',  # noqa: E501
        'count': 'count',  # noqa: E501
        'domains_ids': 'domains_ids',  # noqa: E501
        'start_on': 'start_on',  # noqa: E501
        'template': 'template',  # noqa: E501
        'replication': 'replication',  # noqa: E501
        'cloud_init': 'cloud_init',  # noqa: E501
        'cloud_init_config': 'cloud_init_config',  # noqa: E501
        'memory_count': 'memory_count',  # noqa: E501
        'cpu_topology': 'cpu_topology',  # noqa: E501
        'vmachine_infs': 'vmachine_infs',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """DomainClone - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            idempotency_key (str): Уникальный uuid задачи. [optional]  # noqa: E501
            node (str): Id узла назначения. [optional]  # noqa: E501
            resource_pool (str): Id пула ресурсов назначения. [optional]  # noqa: E501
            verbose_name (str): [optional]  # noqa: E501
            datapool (str): Id пула данных назначения. [optional]  # noqa: E501
            snapshot (str): Id снимка памяти, с которого будет делаться клон. [optional]  # noqa: E501
            count (int): Количество создаваемых клонов. [optional]  # noqa: E501
            domains_ids ([str]): [optional]  # noqa: E501
            start_on (bool): [optional]  # noqa: E501
            template (bool): [optional]  # noqa: E501
            replication (bool): Создать клон для репликации.. [optional]  # noqa: E501
            cloud_init (bool): [optional]  # noqa: E501
            cloud_init_config (CloudConfig): [optional]  # noqa: E501
            memory_count (int): [optional]  # noqa: E501
            cpu_topology ([UpdateResources]): [optional]  # noqa: E501
            vmachine_infs ([VMachineInfSoftCreate]): [optional] if omitted the server will use the default value of []  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """DomainClone - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            idempotency_key (str): Уникальный uuid задачи. [optional]  # noqa: E501
            node (str): Id узла назначения. [optional]  # noqa: E501
            resource_pool (str): Id пула ресурсов назначения. [optional]  # noqa: E501
            verbose_name (str): [optional]  # noqa: E501
            datapool (str): Id пула данных назначения. [optional]  # noqa: E501
            snapshot (str): Id снимка памяти, с которого будет делаться клон. [optional]  # noqa: E501
            count (int): Количество создаваемых клонов. [optional]  # noqa: E501
            domains_ids ([str]): [optional]  # noqa: E501
            start_on (bool): [optional]  # noqa: E501
            template (bool): [optional]  # noqa: E501
            replication (bool): Создать клон для репликации.. [optional]  # noqa: E501
            cloud_init (bool): [optional]  # noqa: E501
            cloud_init_config (CloudConfig): [optional]  # noqa: E501
            memory_count (int): [optional]  # noqa: E501
            cpu_topology ([UpdateResources]): [optional]  # noqa: E501
            vmachine_infs ([VMachineInfSoftCreate]): [optional] if omitted the server will use the default value of []  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
