"""
    Controller API

    Controller description  # noqa: E501

    The version of the OpenAPI document: 6.x.x
    Contact: support@spacevm.ru
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401
from typing import List, Dict

from spacevm_controller_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from spacevm_controller_client.exceptions import ApiAttributeError


def lazy_import():
    from spacevm_controller_client.model.arch_enum import ArchEnum
    from spacevm_controller_client.model.cdrom_soft_post import CdromSoftPost
    from spacevm_controller_client.model.clean_type_enum import CleanTypeEnum
    from spacevm_controller_client.model.cloud_config import CloudConfig
    from spacevm_controller_client.model.domain_add_to_ad import DomainAddToAd
    from spacevm_controller_client.model.domain_controllers import DomainControllers
    from spacevm_controller_client.model.domain_disastery import DomainDisastery
    from spacevm_controller_client.model.domain_ha_options import DomainHAOptions
    from spacevm_controller_client.model.domain_multi_create_boot import DomainMultiCreateBoot
    from spacevm_controller_client.model.domain_remote_access_white_list import DomainRemoteAccessWhiteList
    from spacevm_controller_client.model.iso_attach import IsoAttach
    from spacevm_controller_client.model.iso_soft_attach import IsoSoftAttach
    from spacevm_controller_client.model.lun_attach import LUNAttach
    from spacevm_controller_client.model.machine_enum import MachineEnum
    from spacevm_controller_client.model.mdev_attach import MdevAttach
    from spacevm_controller_client.model.os_type_enum import OsTypeEnum
    from spacevm_controller_client.model.pci_attach import PciAttach
    from spacevm_controller_client.model.ssh_inject import SshInject
    from spacevm_controller_client.model.update_resources import UpdateResources
    from spacevm_controller_client.model.update_sound_device import UpdateSoundDevice
    from spacevm_controller_client.model.update_video_device import UpdateVideoDevice
    from spacevm_controller_client.model.usb_attach import UsbAttach
    from spacevm_controller_client.model.v_function_soft_connect import VFunctionSoftConnect
    from spacevm_controller_client.model.v_machine_inf_soft_create import VMachineInfSoftCreate
    from spacevm_controller_client.model.vdisk_attach import VdiskAttach
    from spacevm_controller_client.model.vdisk_create_attach import VdiskCreateAttach
    from spacevm_controller_client.model.watchdog import Watchdog
    globals()['ArchEnum'] = ArchEnum
    globals()['CdromSoftPost'] = CdromSoftPost
    globals()['CleanTypeEnum'] = CleanTypeEnum
    globals()['CloudConfig'] = CloudConfig
    globals()['DomainAddToAd'] = DomainAddToAd
    globals()['DomainControllers'] = DomainControllers
    globals()['DomainDisastery'] = DomainDisastery
    globals()['DomainHAOptions'] = DomainHAOptions
    globals()['DomainMultiCreateBoot'] = DomainMultiCreateBoot
    globals()['DomainRemoteAccessWhiteList'] = DomainRemoteAccessWhiteList
    globals()['IsoAttach'] = IsoAttach
    globals()['IsoSoftAttach'] = IsoSoftAttach
    globals()['LUNAttach'] = LUNAttach
    globals()['MachineEnum'] = MachineEnum
    globals()['MdevAttach'] = MdevAttach
    globals()['OsTypeEnum'] = OsTypeEnum
    globals()['PciAttach'] = PciAttach
    globals()['SshInject'] = SshInject
    globals()['UpdateResources'] = UpdateResources
    globals()['UpdateSoundDevice'] = UpdateSoundDevice
    globals()['UpdateVideoDevice'] = UpdateVideoDevice
    globals()['UsbAttach'] = UsbAttach
    globals()['VFunctionSoftConnect'] = VFunctionSoftConnect
    globals()['VMachineInfSoftCreate'] = VMachineInfSoftCreate
    globals()['VdiskAttach'] = VdiskAttach
    globals()['VdiskCreateAttach'] = VdiskCreateAttach
    globals()['Watchdog'] = Watchdog


class DomainMultiCreate(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('graphics_password',): {
            'max_length': 16,
        },
        ('clean_count',): {
            'inclusive_maximum': 2,
            'inclusive_minimum': 1,
        },
        ('verbose_name',): {
            'max_length': 255,
        },
        ('description',): {
            'max_length': 255,
        },
        ('memory_count',): {
            'inclusive_minimum': 50,
        },
        ('memory_min_guarantee',): {
            'inclusive_minimum': 0,
        },
        ('memory_shares',): {
            'inclusive_maximum': 10000,
            'inclusive_minimum': 2,
        },
        ('memory_limit',): {
            'inclusive_minimum': 0,
        },
        ('os_version',): {
            'max_length': 60,
        },
        ('count',): {
            'inclusive_maximum': 100,
            'inclusive_minimum': 1,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'os_defaults': (str,),  # noqa: E501
            'idempotency_key': (str,),  # noqa: E501
            'graphics_password': (str,),  # noqa: E501
            'safety': (bool,),  # noqa: E501
            'start_on_boot': (bool,),  # noqa: E501
            'clean_type': (CleanTypeEnum,),  # noqa: E501
            'clean_count': (int,),  # noqa: E501
            'verbose_name': (str,),  # noqa: E501
            'description': (str,),  # noqa: E501
            'node': (str,),  # noqa: E501
            'resource_pool': (str,),  # noqa: E501
            'domain_id': (str,),  # noqa: E501
            'memory_count': (int,),  # noqa: E501
            'memory_min_guarantee': (int,),  # noqa: E501
            'memory_shares': (int,),  # noqa: E501
            'memory_limit': (int,),  # noqa: E501
            'video': (UpdateVideoDevice,),  # noqa: E501
            'sound': (UpdateSoundDevice,),  # noqa: E501
            'watchdog': (Watchdog,),  # noqa: E501
            'boot_type': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'os_type': (OsTypeEnum,),  # noqa: E501
            'os_version': (str,),  # noqa: E501
            'vdisks': ([VdiskAttach],),  # noqa: E501
            'isos': ([IsoAttach],),  # noqa: E501
            'luns': ([LUNAttach],),  # noqa: E501
            'usb_devices': ([UsbAttach],),  # noqa: E501
            'pci_devices': ([PciAttach],),  # noqa: E501
            'mdev_devices': ([MdevAttach],),  # noqa: E501
            'vmachine_infs': ([VMachineInfSoftCreate],),  # noqa: E501
            'vfunction_infs': ([VFunctionSoftConnect],),  # noqa: E501
            'cdroms': ([CdromSoftPost],),  # noqa: E501
            'new_cdroms': ([CdromSoftPost],),  # noqa: E501
            'new_vdisks': ([VdiskCreateAttach],),  # noqa: E501
            'new_luns': ([LUNAttach],),  # noqa: E501
            'new_isos': ([IsoSoftAttach],),  # noqa: E501
            'controllers': (DomainControllers,),  # noqa: E501
            'boot': (DomainMultiCreateBoot,),  # noqa: E501
            'cpu_topology': ([UpdateResources],),  # noqa: E501
            'cpu_topology_info': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'cpu_topology_list': ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}],),  # noqa: E501
            'start_on': (bool,),  # noqa: E501
            'machine': (MachineEnum,),  # noqa: E501
            'arch': (ArchEnum,),  # noqa: E501
            'ha_options': (DomainHAOptions,),  # noqa: E501
            'disastery_options': (DomainDisastery,),  # noqa: E501
            'remote_access': (bool,),  # noqa: E501
            'remote_access_white_list': (DomainRemoteAccessWhiteList,),  # noqa: E501
            'parent': (str,),  # noqa: E501
            'datapool': (str,),  # noqa: E501
            'thin': (bool,),  # noqa: E501
            'clone': (bool,),  # noqa: E501
            'backup_file': (str,),  # noqa: E501
            'compatibility': (str,),  # noqa: E501
            'vdisks_size': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'isos_size': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'map_snapshots': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'current_snapshots': ([bool, date, datetime, dict, float, int, list, str, none_type],),  # noqa: E501
            'template': (bool,),  # noqa: E501
            'tags': ([str],),  # noqa: E501
            'owners': ([int],),  # noqa: E501
            'count': (int,),  # noqa: E501
            'domains_ids': ([str],),  # noqa: E501
            'set_hostname': (bool,),  # noqa: E501
            'add_to_ad': (DomainAddToAd,),  # noqa: E501
            'ssh_inject': (SshInject,),  # noqa: E501
            'cloud_init': (bool,),  # noqa: E501
            'cloud_init_config': (CloudConfig,),  # noqa: E501
            'tpm_device': (bool,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'os_defaults': 'os_defaults',  # noqa: E501
        'idempotency_key': 'idempotency_key',  # noqa: E501
        'graphics_password': 'graphics_password',  # noqa: E501
        'safety': 'safety',  # noqa: E501
        'start_on_boot': 'start_on_boot',  # noqa: E501
        'clean_type': 'clean_type',  # noqa: E501
        'clean_count': 'clean_count',  # noqa: E501
        'verbose_name': 'verbose_name',  # noqa: E501
        'description': 'description',  # noqa: E501
        'node': 'node',  # noqa: E501
        'resource_pool': 'resource_pool',  # noqa: E501
        'domain_id': 'domain_id',  # noqa: E501
        'memory_count': 'memory_count',  # noqa: E501
        'memory_min_guarantee': 'memory_min_guarantee',  # noqa: E501
        'memory_shares': 'memory_shares',  # noqa: E501
        'memory_limit': 'memory_limit',  # noqa: E501
        'video': 'video',  # noqa: E501
        'sound': 'sound',  # noqa: E501
        'watchdog': 'watchdog',  # noqa: E501
        'boot_type': 'boot_type',  # noqa: E501
        'os_type': 'os_type',  # noqa: E501
        'os_version': 'os_version',  # noqa: E501
        'vdisks': 'vdisks',  # noqa: E501
        'isos': 'isos',  # noqa: E501
        'luns': 'luns',  # noqa: E501
        'usb_devices': 'usb_devices',  # noqa: E501
        'pci_devices': 'pci_devices',  # noqa: E501
        'mdev_devices': 'mdev_devices',  # noqa: E501
        'vmachine_infs': 'vmachine_infs',  # noqa: E501
        'vfunction_infs': 'vfunction_infs',  # noqa: E501
        'cdroms': 'cdroms',  # noqa: E501
        'new_cdroms': 'new_cdroms',  # noqa: E501
        'new_vdisks': 'new_vdisks',  # noqa: E501
        'new_luns': 'new_luns',  # noqa: E501
        'new_isos': 'new_isos',  # noqa: E501
        'controllers': 'controllers',  # noqa: E501
        'boot': 'boot',  # noqa: E501
        'cpu_topology': 'cpu_topology',  # noqa: E501
        'cpu_topology_info': 'cpu_topology_info',  # noqa: E501
        'cpu_topology_list': 'cpu_topology_list',  # noqa: E501
        'start_on': 'start_on',  # noqa: E501
        'machine': 'machine',  # noqa: E501
        'arch': 'arch',  # noqa: E501
        'ha_options': 'ha_options',  # noqa: E501
        'disastery_options': 'disastery_options',  # noqa: E501
        'remote_access': 'remote_access',  # noqa: E501
        'remote_access_white_list': 'remote_access_white_list',  # noqa: E501
        'parent': 'parent',  # noqa: E501
        'datapool': 'datapool',  # noqa: E501
        'thin': 'thin',  # noqa: E501
        'clone': 'clone',  # noqa: E501
        'backup_file': 'backup_file',  # noqa: E501
        'compatibility': 'compatibility',  # noqa: E501
        'vdisks_size': 'vdisks_size',  # noqa: E501
        'isos_size': 'isos_size',  # noqa: E501
        'map_snapshots': 'map_snapshots',  # noqa: E501
        'current_snapshots': 'current_snapshots',  # noqa: E501
        'template': 'template',  # noqa: E501
        'tags': 'tags',  # noqa: E501
        'owners': 'owners',  # noqa: E501
        'count': 'count',  # noqa: E501
        'domains_ids': 'domains_ids',  # noqa: E501
        'set_hostname': 'set_hostname',  # noqa: E501
        'add_to_ad': 'add_to_ad',  # noqa: E501
        'ssh_inject': 'ssh_inject',  # noqa: E501
        'cloud_init': 'cloud_init',  # noqa: E501
        'cloud_init_config': 'cloud_init_config',  # noqa: E501
        'tpm_device': 'tpm_device',  # noqa: E501
    }

    read_only_vars = {
        'os_defaults',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, os_defaults, *args, **kwargs):  # noqa: E501
        """DomainMultiCreate - a model defined in OpenAPI

        Args:
            os_defaults (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            idempotency_key (str): Уникальный uuid задачи. [optional]  # noqa: E501
            graphics_password (str): [optional]  # noqa: E501
            safety (bool): [optional]  # noqa: E501
            start_on_boot (bool): [optional]  # noqa: E501
            clean_type (CleanTypeEnum): [optional]  # noqa: E501
            clean_count (int): [optional]  # noqa: E501
            verbose_name (str): [optional]  # noqa: E501
            description (str): [optional]  # noqa: E501
            node (str): [optional]  # noqa: E501
            resource_pool (str): [optional]  # noqa: E501
            domain_id (str): [optional]  # noqa: E501
            memory_count (int): [optional]  # noqa: E501
            memory_min_guarantee (int): [optional]  # noqa: E501
            memory_shares (int): приоритет памяти ВМ относительно других ВМ. [optional]  # noqa: E501
            memory_limit (int): [optional]  # noqa: E501
            video (UpdateVideoDevice): [optional]  # noqa: E501
            sound (UpdateSoundDevice): [optional]  # noqa: E501
            watchdog (Watchdog): [optional]  # noqa: E501
            boot_type (bool, date, datetime, dict, float, int, list, str, none_type): Deprecated. Рекомендуется использовать параметр boot.. [optional]  # noqa: E501
            os_type (OsTypeEnum): [optional]  # noqa: E501
            os_version (str): [optional]  # noqa: E501
            vdisks ([VdiskAttach]): [optional] if omitted the server will use the default value of []  # noqa: E501
            isos ([IsoAttach]): [optional] if omitted the server will use the default value of []  # noqa: E501
            luns ([LUNAttach]): [optional] if omitted the server will use the default value of []  # noqa: E501
            usb_devices ([UsbAttach]): [optional] if omitted the server will use the default value of []  # noqa: E501
            pci_devices ([PciAttach]): [optional] if omitted the server will use the default value of []  # noqa: E501
            mdev_devices ([MdevAttach]): [optional] if omitted the server will use the default value of []  # noqa: E501
            vmachine_infs ([VMachineInfSoftCreate]): [optional] if omitted the server will use the default value of []  # noqa: E501
            vfunction_infs ([VFunctionSoftConnect]): [optional] if omitted the server will use the default value of []  # noqa: E501
            cdroms ([CdromSoftPost]): [optional] if omitted the server will use the default value of []  # noqa: E501
            new_cdroms ([CdromSoftPost]): [optional] if omitted the server will use the default value of []  # noqa: E501
            new_vdisks ([VdiskCreateAttach]): [optional] if omitted the server will use the default value of []  # noqa: E501
            new_luns ([LUNAttach]): [optional] if omitted the server will use the default value of []  # noqa: E501
            new_isos ([IsoSoftAttach]): [optional] if omitted the server will use the default value of []  # noqa: E501
            controllers (DomainControllers): [optional]  # noqa: E501
            boot (DomainMultiCreateBoot): [optional]  # noqa: E501
            cpu_topology ([UpdateResources]): [optional]  # noqa: E501
            cpu_topology_info ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): for compatibility. [optional]  # noqa: E501
            cpu_topology_list ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]): for compatibility. [optional]  # noqa: E501
            start_on (bool): [optional] if omitted the server will use the default value of False  # noqa: E501
            machine (MachineEnum): [optional]  # noqa: E501
            arch (ArchEnum): [optional]  # noqa: E501
            ha_options (DomainHAOptions): [optional]  # noqa: E501
            disastery_options (DomainDisastery): [optional]  # noqa: E501
            remote_access (bool): [optional]  # noqa: E501
            remote_access_white_list (DomainRemoteAccessWhiteList): [optional]  # noqa: E501
            parent (str): [optional]  # noqa: E501
            datapool (str): [optional]  # noqa: E501
            thin (bool): [optional] if omitted the server will use the default value of False  # noqa: E501
            clone (bool): [optional] if omitted the server will use the default value of False  # noqa: E501
            backup_file (str): Файл резервной копии UUID для восстановления виртуальной машины.. [optional]  # noqa: E501
            compatibility (str): UUID для совместимости резервного копирования и клонирования с шаблоном.. [optional]  # noqa: E501
            vdisks_size ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): {<str uuid vdisk>: <virtual size in bytes>, ...}. [optional]  # noqa: E501
            isos_size ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): {<str file name iso>: <actual size in bytes>, ...}. [optional]  # noqa: E501
            map_snapshots ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): {<snapshot_file>: <backing_file>, ...}. [optional]  # noqa: E501
            current_snapshots ([bool, date, datetime, dict, float, int, list, str, none_type]): [</path/to/uuid.snapshot>, ...] from xml. [optional]  # noqa: E501
            template (bool): [optional]  # noqa: E501
            tags ([str]): [optional]  # noqa: E501
            owners ([int]): Список id пользователей. [optional]  # noqa: E501
            count (int): Количество создаваемых ВМ. [optional]  # noqa: E501
            domains_ids ([str]): [optional]  # noqa: E501
            set_hostname (bool): Установка verbose_name в качестве имени хоста домена.. [optional]  # noqa: E501
            add_to_ad (DomainAddToAd): [optional]  # noqa: E501
            ssh_inject (SshInject): [optional]  # noqa: E501
            cloud_init (bool): [optional]  # noqa: E501
            cloud_init_config (CloudConfig): [optional]  # noqa: E501
            tpm_device (bool): [optional] if omitted the server will use the default value of False  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.os_defaults = os_defaults
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """DomainMultiCreate - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            idempotency_key (str): Уникальный uuid задачи. [optional]  # noqa: E501
            graphics_password (str): [optional]  # noqa: E501
            safety (bool): [optional]  # noqa: E501
            start_on_boot (bool): [optional]  # noqa: E501
            clean_type (CleanTypeEnum): [optional]  # noqa: E501
            clean_count (int): [optional]  # noqa: E501
            verbose_name (str): [optional]  # noqa: E501
            description (str): [optional]  # noqa: E501
            node (str): [optional]  # noqa: E501
            resource_pool (str): [optional]  # noqa: E501
            domain_id (str): [optional]  # noqa: E501
            memory_count (int): [optional]  # noqa: E501
            memory_min_guarantee (int): [optional]  # noqa: E501
            memory_shares (int): приоритет памяти ВМ относительно других ВМ. [optional]  # noqa: E501
            memory_limit (int): [optional]  # noqa: E501
            video (UpdateVideoDevice): [optional]  # noqa: E501
            sound (UpdateSoundDevice): [optional]  # noqa: E501
            watchdog (Watchdog): [optional]  # noqa: E501
            boot_type (bool, date, datetime, dict, float, int, list, str, none_type): Deprecated. Рекомендуется использовать параметр boot.. [optional]  # noqa: E501
            os_type (OsTypeEnum): [optional]  # noqa: E501
            os_version (str): [optional]  # noqa: E501
            vdisks ([VdiskAttach]): [optional] if omitted the server will use the default value of []  # noqa: E501
            isos ([IsoAttach]): [optional] if omitted the server will use the default value of []  # noqa: E501
            luns ([LUNAttach]): [optional] if omitted the server will use the default value of []  # noqa: E501
            usb_devices ([UsbAttach]): [optional] if omitted the server will use the default value of []  # noqa: E501
            pci_devices ([PciAttach]): [optional] if omitted the server will use the default value of []  # noqa: E501
            mdev_devices ([MdevAttach]): [optional] if omitted the server will use the default value of []  # noqa: E501
            vmachine_infs ([VMachineInfSoftCreate]): [optional] if omitted the server will use the default value of []  # noqa: E501
            vfunction_infs ([VFunctionSoftConnect]): [optional] if omitted the server will use the default value of []  # noqa: E501
            cdroms ([CdromSoftPost]): [optional] if omitted the server will use the default value of []  # noqa: E501
            new_cdroms ([CdromSoftPost]): [optional] if omitted the server will use the default value of []  # noqa: E501
            new_vdisks ([VdiskCreateAttach]): [optional] if omitted the server will use the default value of []  # noqa: E501
            new_luns ([LUNAttach]): [optional] if omitted the server will use the default value of []  # noqa: E501
            new_isos ([IsoSoftAttach]): [optional] if omitted the server will use the default value of []  # noqa: E501
            controllers (DomainControllers): [optional]  # noqa: E501
            boot (DomainMultiCreateBoot): [optional]  # noqa: E501
            cpu_topology ([UpdateResources]): [optional]  # noqa: E501
            cpu_topology_info ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): for compatibility. [optional]  # noqa: E501
            cpu_topology_list ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]): for compatibility. [optional]  # noqa: E501
            start_on (bool): [optional] if omitted the server will use the default value of False  # noqa: E501
            machine (MachineEnum): [optional]  # noqa: E501
            arch (ArchEnum): [optional]  # noqa: E501
            ha_options (DomainHAOptions): [optional]  # noqa: E501
            disastery_options (DomainDisastery): [optional]  # noqa: E501
            remote_access (bool): [optional]  # noqa: E501
            remote_access_white_list (DomainRemoteAccessWhiteList): [optional]  # noqa: E501
            parent (str): [optional]  # noqa: E501
            datapool (str): [optional]  # noqa: E501
            thin (bool): [optional] if omitted the server will use the default value of False  # noqa: E501
            clone (bool): [optional] if omitted the server will use the default value of False  # noqa: E501
            backup_file (str): Файл резервной копии UUID для восстановления виртуальной машины.. [optional]  # noqa: E501
            compatibility (str): UUID для совместимости резервного копирования и клонирования с шаблоном.. [optional]  # noqa: E501
            vdisks_size ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): {<str uuid vdisk>: <virtual size in bytes>, ...}. [optional]  # noqa: E501
            isos_size ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): {<str file name iso>: <actual size in bytes>, ...}. [optional]  # noqa: E501
            map_snapshots ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): {<snapshot_file>: <backing_file>, ...}. [optional]  # noqa: E501
            current_snapshots ([bool, date, datetime, dict, float, int, list, str, none_type]): [</path/to/uuid.snapshot>, ...] from xml. [optional]  # noqa: E501
            template (bool): [optional]  # noqa: E501
            tags ([str]): [optional]  # noqa: E501
            owners ([int]): Список id пользователей. [optional]  # noqa: E501
            count (int): Количество создаваемых ВМ. [optional]  # noqa: E501
            domains_ids ([str]): [optional]  # noqa: E501
            set_hostname (bool): Установка verbose_name в качестве имени хоста домена.. [optional]  # noqa: E501
            add_to_ad (DomainAddToAd): [optional]  # noqa: E501
            ssh_inject (SshInject): [optional]  # noqa: E501
            cloud_init (bool): [optional]  # noqa: E501
            cloud_init_config (CloudConfig): [optional]  # noqa: E501
            tpm_device (bool): [optional] if omitted the server will use the default value of False  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
