"""
    Controller API

    Controller description  # noqa: E501

    The version of the OpenAPI document: 6.x.x
    Contact: support@spacevm.ru
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401
from typing import List, Dict

from spacevm_controller_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from spacevm_controller_client.exceptions import ApiAttributeError


def lazy_import():
    from spacevm_controller_client.model.name_owner import NameOwner
    globals()['NameOwner'] = NameOwner


class DomainObject(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('verbose_name',): {
            'max_length': 255,
        },
        ('memory_count',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('priority',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('status',): {
            'max_length': 20,
        },
        ('memory_min_guarantee',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('memory_shares',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('memory_limit',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('os_type',): {
            'max_length': 10,
        },
        ('os_version',): {
            'max_length': 60,
        },
        ('os_version_id',): {
            'max_length': 60,
        },
        ('ha_boot_order',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('graphics_password',): {
            'max_length': 16,
        },
        ('remote_access_port',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('real_remote_access_port',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('machine',): {
            'max_length': 20,
        },
        ('arch',): {
            'max_length': 20,
        },
        ('clean_count',): {
            'inclusive_maximum': 2,
            'inclusive_minimum': 1,
        },
        ('clean_type',): {
            'max_length': 10,
        },
        ('bootmenu_timeout',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('boot_type',): {
            'max_length': 10,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'id': (str,),  # noqa: E501
            'verbose_name': (str,),  # noqa: E501
            'entity_type': (str,),  # noqa: E501
            'guest_utils': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'created': (datetime,),  # noqa: E501
            'modified': (datetime,),  # noqa: E501
            'user_power_state': (int,),  # noqa: E501
            'cpu_type': (str,),  # noqa: E501
            'tpm_device': (bool,),  # noqa: E501
            'memory_count': (int,),  # noqa: E501
            'cpu_used_percent_user': (str,),  # noqa: E501
            'mem_used_percent_user': (str,),  # noqa: E501
            'parent': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'owners': ([NameOwner],),  # noqa: E501
            'os_defaults': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'node': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'resource_pool': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'cluster': (str,),  # noqa: E501
            'uptime_on_current_node': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'uptime_total': (int,),  # noqa: E501
            'ha_enabled': (bool,),  # noqa: E501
            'ha_autoselect': (bool,),  # noqa: E501
            'ha_nodepolicy': ([bool, date, datetime, dict, float, int, list, str, none_type],),  # noqa: E501
            'ha_retrycount': (int,),  # noqa: E501
            'ha_timeout': (int,),  # noqa: E501
            'ha_options_cluster_sync': (bool,),  # noqa: E501
            'ha_boot_delay': (int,),  # noqa: E501
            'ha_boot_agent': (bool,),  # noqa: E501
            'remote_access_white_list': ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}],),  # noqa: E501
            'consoles': ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}],),  # noqa: E501
            'user_xml': (str,),  # noqa: E501
            'features': ([str],),  # noqa: E501
            'qemu_args': ([str],),  # noqa: E501
            'gpu_optimize': (bool,),  # noqa: E501
            'usb_devices': ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}],),  # noqa: E501
            'pci_devices': ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}],),  # noqa: E501
            'mdev_devices': ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}],),  # noqa: E501
            'tcp_usb_devices': ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}],),  # noqa: E501
            'spice_usb_channels': ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}],),  # noqa: E501
            'free_slots': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'hints': (int,),  # noqa: E501
            'tags': ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}],),  # noqa: E501
            'permissions': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'description': (str,),  # noqa: E501
            'locked_by': (str, none_type,),  # noqa: E501
            'priority': (int,),  # noqa: E501
            'start_on_boot': (bool,),  # noqa: E501
            'status': (str,),  # noqa: E501
            'migrated': (datetime, none_type,),  # noqa: E501
            'cpu_topology': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'memory_min_guarantee': (int,),  # noqa: E501
            'memory_shares': (int,),  # noqa: E501
            'memory_limit': (int,),  # noqa: E501
            'memory_pool': (str, none_type,),  # noqa: E501
            'current_state': (str, none_type,),  # noqa: E501
            'applied_snapshot': (str, none_type,),  # noqa: E501
            'template': (bool,),  # noqa: E501
            'thin': (bool,),  # noqa: E501
            'os_type': (str,),  # noqa: E501
            'os_version': (str,),  # noqa: E501
            'os_version_id': (str,),  # noqa: E501
            'cloud_init': (bool,),  # noqa: E501
            'cloud_init_config': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'ha_boot_order': (int,),  # noqa: E501
            'graphics_password': (str,),  # noqa: E501
            'graphics_settings': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'remote_access_port': (int, none_type,),  # noqa: E501
            'remote_access_allow_all': (bool,),  # noqa: E501
            'remote_access': (bool,),  # noqa: E501
            'real_remote_access_port': (int, none_type,),  # noqa: E501
            'video': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'sound': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'tablet': (bool,),  # noqa: E501
            'spice_stream': (bool,),  # noqa: E501
            'machine': (str,),  # noqa: E501
            'arch': (str,),  # noqa: E501
            'clean_count': (int,),  # noqa: E501
            'clean_type': (str,),  # noqa: E501
            'safety': (bool,),  # noqa: E501
            'disastery_enabled': (bool,),  # noqa: E501
            'bootmenu': (bool,),  # noqa: E501
            'bootmenu_timeout': (int,),  # noqa: E501
            'boot_type': (str,),  # noqa: E501
            'watchdog': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'controllers': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'verbose_name': 'verbose_name',  # noqa: E501
        'entity_type': 'entity_type',  # noqa: E501
        'guest_utils': 'guest_utils',  # noqa: E501
        'created': 'created',  # noqa: E501
        'modified': 'modified',  # noqa: E501
        'user_power_state': 'user_power_state',  # noqa: E501
        'cpu_type': 'cpu_type',  # noqa: E501
        'tpm_device': 'tpm_device',  # noqa: E501
        'memory_count': 'memory_count',  # noqa: E501
        'cpu_used_percent_user': 'cpu_used_percent_user',  # noqa: E501
        'mem_used_percent_user': 'mem_used_percent_user',  # noqa: E501
        'parent': 'parent',  # noqa: E501
        'owners': 'owners',  # noqa: E501
        'os_defaults': 'os_defaults',  # noqa: E501
        'node': 'node',  # noqa: E501
        'resource_pool': 'resource_pool',  # noqa: E501
        'cluster': 'cluster',  # noqa: E501
        'uptime_on_current_node': 'uptime_on_current_node',  # noqa: E501
        'uptime_total': 'uptime_total',  # noqa: E501
        'ha_enabled': 'ha_enabled',  # noqa: E501
        'ha_autoselect': 'ha_autoselect',  # noqa: E501
        'ha_nodepolicy': 'ha_nodepolicy',  # noqa: E501
        'ha_retrycount': 'ha_retrycount',  # noqa: E501
        'ha_timeout': 'ha_timeout',  # noqa: E501
        'ha_options_cluster_sync': 'ha_options_cluster_sync',  # noqa: E501
        'ha_boot_delay': 'ha_boot_delay',  # noqa: E501
        'ha_boot_agent': 'ha_boot_agent',  # noqa: E501
        'remote_access_white_list': 'remote_access_white_list',  # noqa: E501
        'consoles': 'consoles',  # noqa: E501
        'user_xml': 'user_xml',  # noqa: E501
        'features': 'features',  # noqa: E501
        'qemu_args': 'qemu_args',  # noqa: E501
        'gpu_optimize': 'gpu_optimize',  # noqa: E501
        'usb_devices': 'usb_devices',  # noqa: E501
        'pci_devices': 'pci_devices',  # noqa: E501
        'mdev_devices': 'mdev_devices',  # noqa: E501
        'tcp_usb_devices': 'tcp_usb_devices',  # noqa: E501
        'spice_usb_channels': 'spice_usb_channels',  # noqa: E501
        'free_slots': 'free_slots',  # noqa: E501
        'hints': 'hints',  # noqa: E501
        'tags': 'tags',  # noqa: E501
        'permissions': 'permissions',  # noqa: E501
        'description': 'description',  # noqa: E501
        'locked_by': 'locked_by',  # noqa: E501
        'priority': 'priority',  # noqa: E501
        'start_on_boot': 'start_on_boot',  # noqa: E501
        'status': 'status',  # noqa: E501
        'migrated': 'migrated',  # noqa: E501
        'cpu_topology': 'cpu_topology',  # noqa: E501
        'memory_min_guarantee': 'memory_min_guarantee',  # noqa: E501
        'memory_shares': 'memory_shares',  # noqa: E501
        'memory_limit': 'memory_limit',  # noqa: E501
        'memory_pool': 'memory_pool',  # noqa: E501
        'current_state': 'current_state',  # noqa: E501
        'applied_snapshot': 'applied_snapshot',  # noqa: E501
        'template': 'template',  # noqa: E501
        'thin': 'thin',  # noqa: E501
        'os_type': 'os_type',  # noqa: E501
        'os_version': 'os_version',  # noqa: E501
        'os_version_id': 'os_version_id',  # noqa: E501
        'cloud_init': 'cloud_init',  # noqa: E501
        'cloud_init_config': 'cloud_init_config',  # noqa: E501
        'ha_boot_order': 'ha_boot_order',  # noqa: E501
        'graphics_password': 'graphics_password',  # noqa: E501
        'graphics_settings': 'graphics_settings',  # noqa: E501
        'remote_access_port': 'remote_access_port',  # noqa: E501
        'remote_access_allow_all': 'remote_access_allow_all',  # noqa: E501
        'remote_access': 'remote_access',  # noqa: E501
        'real_remote_access_port': 'real_remote_access_port',  # noqa: E501
        'video': 'video',  # noqa: E501
        'sound': 'sound',  # noqa: E501
        'tablet': 'tablet',  # noqa: E501
        'spice_stream': 'spice_stream',  # noqa: E501
        'machine': 'machine',  # noqa: E501
        'arch': 'arch',  # noqa: E501
        'clean_count': 'clean_count',  # noqa: E501
        'clean_type': 'clean_type',  # noqa: E501
        'safety': 'safety',  # noqa: E501
        'disastery_enabled': 'disastery_enabled',  # noqa: E501
        'bootmenu': 'bootmenu',  # noqa: E501
        'bootmenu_timeout': 'bootmenu_timeout',  # noqa: E501
        'boot_type': 'boot_type',  # noqa: E501
        'watchdog': 'watchdog',  # noqa: E501
        'controllers': 'controllers',  # noqa: E501
    }

    read_only_vars = {
        'id',  # noqa: E501
        'entity_type',  # noqa: E501
        'created',  # noqa: E501
        'modified',  # noqa: E501
        'cpu_type',  # noqa: E501
        'tpm_device',  # noqa: E501
        'cpu_used_percent_user',  # noqa: E501
        'mem_used_percent_user',  # noqa: E501
        'parent',  # noqa: E501
        'owners',  # noqa: E501
        'os_defaults',  # noqa: E501
        'node',  # noqa: E501
        'resource_pool',  # noqa: E501
        'remote_access_white_list',  # noqa: E501
        'consoles',  # noqa: E501
        'features',  # noqa: E501
        'qemu_args',  # noqa: E501
        'usb_devices',  # noqa: E501
        'pci_devices',  # noqa: E501
        'mdev_devices',  # noqa: E501
        'tcp_usb_devices',  # noqa: E501
        'spice_usb_channels',  # noqa: E501
        'hints',  # noqa: E501
        'tags',  # noqa: E501
        'permissions',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, id, verbose_name, entity_type, guest_utils, created, modified, user_power_state, cpu_type, tpm_device, memory_count, cpu_used_percent_user, mem_used_percent_user, parent, owners, os_defaults, node, resource_pool, cluster, uptime_on_current_node, uptime_total, ha_enabled, ha_autoselect, ha_nodepolicy, ha_retrycount, ha_timeout, ha_options_cluster_sync, ha_boot_delay, ha_boot_agent, remote_access_white_list, consoles, user_xml, features, qemu_args, gpu_optimize, usb_devices, pci_devices, mdev_devices, tcp_usb_devices, spice_usb_channels, free_slots, hints, tags, permissions, *args, **kwargs):  # noqa: E501
        """DomainObject - a model defined in OpenAPI

        Args:
            id (str):
            verbose_name (str):
            entity_type (str):
            guest_utils ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            created (datetime):
            modified (datetime):
            user_power_state (int):
            cpu_type (str):
            tpm_device (bool):
            memory_count (int):
            cpu_used_percent_user (str):
            mem_used_percent_user (str):
            parent (bool, date, datetime, dict, float, int, list, str, none_type):
            owners ([NameOwner]):
            os_defaults (bool, date, datetime, dict, float, int, list, str, none_type):
            node (bool, date, datetime, dict, float, int, list, str, none_type):
            resource_pool (bool, date, datetime, dict, float, int, list, str, none_type):
            cluster (str):
            uptime_on_current_node ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            uptime_total (int):
            ha_enabled (bool):
            ha_autoselect (bool):
            ha_nodepolicy ([bool, date, datetime, dict, float, int, list, str, none_type]):
            ha_retrycount (int):
            ha_timeout (int):
            ha_options_cluster_sync (bool):
            ha_boot_delay (int):
            ha_boot_agent (bool):
            remote_access_white_list ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]):
            consoles ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]):
            user_xml (str):
            features ([str]):
            qemu_args ([str]):
            gpu_optimize (bool):
            usb_devices ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]):
            pci_devices ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]):
            mdev_devices ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]):
            tcp_usb_devices ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]):
            spice_usb_channels ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]):
            free_slots ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            hints (int):
            tags ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]):
            permissions (bool, date, datetime, dict, float, int, list, str, none_type): Список разрешенных действий с моделью для текущего пользователя.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            description (str): [optional]  # noqa: E501
            locked_by (str, none_type): [optional]  # noqa: E501
            priority (int): [optional]  # noqa: E501
            start_on_boot (bool): [optional]  # noqa: E501
            status (str): [optional]  # noqa: E501
            migrated (datetime, none_type): [optional]  # noqa: E501
            cpu_topology ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            memory_min_guarantee (int): [optional]  # noqa: E501
            memory_shares (int): [optional]  # noqa: E501
            memory_limit (int): [optional]  # noqa: E501
            memory_pool (str, none_type): [optional]  # noqa: E501
            current_state (str, none_type): [optional]  # noqa: E501
            applied_snapshot (str, none_type): [optional]  # noqa: E501
            template (bool): [optional]  # noqa: E501
            thin (bool): [optional]  # noqa: E501
            os_type (str): [optional]  # noqa: E501
            os_version (str): [optional]  # noqa: E501
            os_version_id (str): [optional]  # noqa: E501
            cloud_init (bool): [optional]  # noqa: E501
            cloud_init_config ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            ha_boot_order (int): [optional]  # noqa: E501
            graphics_password (str): [optional]  # noqa: E501
            graphics_settings ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            remote_access_port (int, none_type): [optional]  # noqa: E501
            remote_access_allow_all (bool): [optional]  # noqa: E501
            remote_access (bool): [optional]  # noqa: E501
            real_remote_access_port (int, none_type): [optional]  # noqa: E501
            video ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            sound ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            tablet (bool): [optional]  # noqa: E501
            spice_stream (bool): [optional]  # noqa: E501
            machine (str): [optional]  # noqa: E501
            arch (str): [optional]  # noqa: E501
            clean_count (int): [optional]  # noqa: E501
            clean_type (str): [optional]  # noqa: E501
            safety (bool): [optional]  # noqa: E501
            disastery_enabled (bool): [optional]  # noqa: E501
            bootmenu (bool): [optional]  # noqa: E501
            bootmenu_timeout (int): [optional]  # noqa: E501
            boot_type (str): [optional]  # noqa: E501
            watchdog ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            controllers ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.id = id
        self.verbose_name = verbose_name
        self.entity_type = entity_type
        self.guest_utils = guest_utils
        self.created = created
        self.modified = modified
        self.user_power_state = user_power_state
        self.cpu_type = cpu_type
        self.tpm_device = tpm_device
        self.memory_count = memory_count
        self.cpu_used_percent_user = cpu_used_percent_user
        self.mem_used_percent_user = mem_used_percent_user
        self.parent = parent
        self.owners = owners
        self.os_defaults = os_defaults
        self.node = node
        self.resource_pool = resource_pool
        self.cluster = cluster
        self.uptime_on_current_node = uptime_on_current_node
        self.uptime_total = uptime_total
        self.ha_enabled = ha_enabled
        self.ha_autoselect = ha_autoselect
        self.ha_nodepolicy = ha_nodepolicy
        self.ha_retrycount = ha_retrycount
        self.ha_timeout = ha_timeout
        self.ha_options_cluster_sync = ha_options_cluster_sync
        self.ha_boot_delay = ha_boot_delay
        self.ha_boot_agent = ha_boot_agent
        self.remote_access_white_list = remote_access_white_list
        self.consoles = consoles
        self.user_xml = user_xml
        self.features = features
        self.qemu_args = qemu_args
        self.gpu_optimize = gpu_optimize
        self.usb_devices = usb_devices
        self.pci_devices = pci_devices
        self.mdev_devices = mdev_devices
        self.tcp_usb_devices = tcp_usb_devices
        self.spice_usb_channels = spice_usb_channels
        self.free_slots = free_slots
        self.hints = hints
        self.tags = tags
        self.permissions = permissions
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, verbose_name, guest_utils, user_power_state, memory_count, cluster, uptime_on_current_node, uptime_total, ha_enabled, ha_autoselect, ha_nodepolicy, ha_retrycount, ha_timeout, ha_options_cluster_sync, ha_boot_delay, ha_boot_agent, user_xml, gpu_optimize, free_slots, *args, **kwargs):  # noqa: E501
        """DomainObject - a model defined in OpenAPI

            verbose_name (str):
            guest_utils ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            user_power_state (int):
            memory_count (int):
            cluster (str):
            uptime_on_current_node ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            uptime_total (int):
            ha_enabled (bool):
            ha_autoselect (bool):
            ha_nodepolicy ([bool, date, datetime, dict, float, int, list, str, none_type]):
            ha_retrycount (int):
            ha_timeout (int):
            ha_options_cluster_sync (bool):
            ha_boot_delay (int):
            ha_boot_agent (bool):
            user_xml (str):
            gpu_optimize (bool):
            free_slots ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            description (str): [optional]  # noqa: E501
            locked_by (str, none_type): [optional]  # noqa: E501
            priority (int): [optional]  # noqa: E501
            start_on_boot (bool): [optional]  # noqa: E501
            status (str): [optional]  # noqa: E501
            migrated (datetime, none_type): [optional]  # noqa: E501
            cpu_topology ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            memory_min_guarantee (int): [optional]  # noqa: E501
            memory_shares (int): [optional]  # noqa: E501
            memory_limit (int): [optional]  # noqa: E501
            memory_pool (str, none_type): [optional]  # noqa: E501
            current_state (str, none_type): [optional]  # noqa: E501
            applied_snapshot (str, none_type): [optional]  # noqa: E501
            template (bool): [optional]  # noqa: E501
            thin (bool): [optional]  # noqa: E501
            os_type (str): [optional]  # noqa: E501
            os_version (str): [optional]  # noqa: E501
            os_version_id (str): [optional]  # noqa: E501
            cloud_init (bool): [optional]  # noqa: E501
            cloud_init_config ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            ha_boot_order (int): [optional]  # noqa: E501
            graphics_password (str): [optional]  # noqa: E501
            graphics_settings ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            remote_access_port (int, none_type): [optional]  # noqa: E501
            remote_access_allow_all (bool): [optional]  # noqa: E501
            remote_access (bool): [optional]  # noqa: E501
            real_remote_access_port (int, none_type): [optional]  # noqa: E501
            video ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            sound ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            tablet (bool): [optional]  # noqa: E501
            spice_stream (bool): [optional]  # noqa: E501
            machine (str): [optional]  # noqa: E501
            arch (str): [optional]  # noqa: E501
            clean_count (int): [optional]  # noqa: E501
            clean_type (str): [optional]  # noqa: E501
            safety (bool): [optional]  # noqa: E501
            disastery_enabled (bool): [optional]  # noqa: E501
            bootmenu (bool): [optional]  # noqa: E501
            bootmenu_timeout (int): [optional]  # noqa: E501
            boot_type (str): [optional]  # noqa: E501
            watchdog ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            controllers ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.verbose_name = verbose_name
        self.guest_utils = guest_utils
        self.user_power_state = user_power_state
        self.memory_count = memory_count
        self.cluster = cluster
        self.uptime_on_current_node = uptime_on_current_node
        self.uptime_total = uptime_total
        self.ha_enabled = ha_enabled
        self.ha_autoselect = ha_autoselect
        self.ha_nodepolicy = ha_nodepolicy
        self.ha_retrycount = ha_retrycount
        self.ha_timeout = ha_timeout
        self.ha_options_cluster_sync = ha_options_cluster_sync
        self.ha_boot_delay = ha_boot_delay
        self.ha_boot_agent = ha_boot_agent
        self.user_xml = user_xml
        self.gpu_optimize = gpu_optimize
        self.free_slots = free_slots
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
