"""
    Controller API

    Controller description  # noqa: E501

    The version of the OpenAPI document: 6.x.x
    Contact: support@spacevm.ru
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401
from typing import List, Dict

from spacevm_controller_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from spacevm_controller_client.exceptions import ApiAttributeError



class SwaggerControllerObject(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('verbose_name',): {
            'max_length': 255,
        },
        ('management_address',): {
            'max_length': 255,
        },
        ('kernel_address',): {
            'max_length': 255,
        },
        ('mac_part',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('heartbeat_start_timeout',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('fencer_initial_timeout',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('fencer_max_timeout',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('fencer_multiplier_timeout',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('min_records_to_backup',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('backup_directory_capacity',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('backup_directory_warning',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('required_days_to_clear_archives',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('version',): {
            'max_length': 10,
        },
        ('default_name_pattern',): {
            'max_length': 63,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'id': (str,),  # noqa: E501
            'entity_type': (str,),  # noqa: E501
            'created': (datetime,),  # noqa: E501
            'modified': (datetime,),  # noqa: E501
            'readable_smtp_settings': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'hints': (int,),  # noqa: E501
            'verbose_name': (str,),  # noqa: E501
            'management_address': (str,),  # noqa: E501
            'kernel_address': (str,),  # noqa: E501
            'mac_part': (int,),  # noqa: E501
            'veil_controllers': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'options': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'heartbeat_start_timeout': (int,),  # noqa: E501
            'locked_by': (str, none_type,),  # noqa: E501
            'fencer_initial_timeout': (int,),  # noqa: E501
            'fencer_max_timeout': (int,),  # noqa: E501
            'fencer_multiplier_timeout': (int,),  # noqa: E501
            'fencer_set_to_failed_after_timeout': (bool,),  # noqa: E501
            'min_records_to_backup': (int,),  # noqa: E501
            'backup_directory_capacity': (int,),  # noqa: E501
            'backup_directory_warning': (int,),  # noqa: E501
            'required_days_to_clear_archives': (int,),  # noqa: E501
            'clear_archives_enabled': (bool,),  # noqa: E501
            'version': (str,),  # noqa: E501
            'auto_sync_network': (bool,),  # noqa: E501
            'auto_scan_storages': (bool,),  # noqa: E501
            'ntp_servers': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'cpu_topology': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'default_name_pattern': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'entity_type': 'entity_type',  # noqa: E501
        'created': 'created',  # noqa: E501
        'modified': 'modified',  # noqa: E501
        'readable_smtp_settings': 'readable_smtp_settings',  # noqa: E501
        'hints': 'hints',  # noqa: E501
        'verbose_name': 'verbose_name',  # noqa: E501
        'management_address': 'management_address',  # noqa: E501
        'kernel_address': 'kernel_address',  # noqa: E501
        'mac_part': 'mac_part',  # noqa: E501
        'veil_controllers': 'veil_controllers',  # noqa: E501
        'options': 'options',  # noqa: E501
        'heartbeat_start_timeout': 'heartbeat_start_timeout',  # noqa: E501
        'locked_by': 'locked_by',  # noqa: E501
        'fencer_initial_timeout': 'fencer_initial_timeout',  # noqa: E501
        'fencer_max_timeout': 'fencer_max_timeout',  # noqa: E501
        'fencer_multiplier_timeout': 'fencer_multiplier_timeout',  # noqa: E501
        'fencer_set_to_failed_after_timeout': 'fencer_set_to_failed_after_timeout',  # noqa: E501
        'min_records_to_backup': 'min_records_to_backup',  # noqa: E501
        'backup_directory_capacity': 'backup_directory_capacity',  # noqa: E501
        'backup_directory_warning': 'backup_directory_warning',  # noqa: E501
        'required_days_to_clear_archives': 'required_days_to_clear_archives',  # noqa: E501
        'clear_archives_enabled': 'clear_archives_enabled',  # noqa: E501
        'version': 'version',  # noqa: E501
        'auto_sync_network': 'auto_sync_network',  # noqa: E501
        'auto_scan_storages': 'auto_scan_storages',  # noqa: E501
        'ntp_servers': 'ntp_servers',  # noqa: E501
        'cpu_topology': 'cpu_topology',  # noqa: E501
        'default_name_pattern': 'default_name_pattern',  # noqa: E501
    }

    read_only_vars = {
        'id',  # noqa: E501
        'entity_type',  # noqa: E501
        'created',  # noqa: E501
        'modified',  # noqa: E501
        'readable_smtp_settings',  # noqa: E501
        'hints',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, id, entity_type, created, modified, readable_smtp_settings, hints, *args, **kwargs):  # noqa: E501
        """SwaggerControllerObject - a model defined in OpenAPI

        Args:
            id (str):
            entity_type (str):
            created (datetime):
            modified (datetime):
            readable_smtp_settings ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            hints (int):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            verbose_name (str): [optional]  # noqa: E501
            management_address (str): [optional]  # noqa: E501
            kernel_address (str): [optional]  # noqa: E501
            mac_part (int): [optional]  # noqa: E501
            veil_controllers ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            options ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            heartbeat_start_timeout (int): [optional]  # noqa: E501
            locked_by (str, none_type): [optional]  # noqa: E501
            fencer_initial_timeout (int): [optional]  # noqa: E501
            fencer_max_timeout (int): [optional]  # noqa: E501
            fencer_multiplier_timeout (int): [optional]  # noqa: E501
            fencer_set_to_failed_after_timeout (bool): [optional]  # noqa: E501
            min_records_to_backup (int): [optional]  # noqa: E501
            backup_directory_capacity (int): [optional]  # noqa: E501
            backup_directory_warning (int): [optional]  # noqa: E501
            required_days_to_clear_archives (int): [optional]  # noqa: E501
            clear_archives_enabled (bool): [optional]  # noqa: E501
            version (str): [optional]  # noqa: E501
            auto_sync_network (bool): [optional]  # noqa: E501
            auto_scan_storages (bool): [optional]  # noqa: E501
            ntp_servers ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            cpu_topology ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            default_name_pattern (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.id = id
        self.entity_type = entity_type
        self.created = created
        self.modified = modified
        self.readable_smtp_settings = readable_smtp_settings
        self.hints = hints
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """SwaggerControllerObject - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            verbose_name (str): [optional]  # noqa: E501
            management_address (str): [optional]  # noqa: E501
            kernel_address (str): [optional]  # noqa: E501
            mac_part (int): [optional]  # noqa: E501
            veil_controllers ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            options ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            heartbeat_start_timeout (int): [optional]  # noqa: E501
            locked_by (str, none_type): [optional]  # noqa: E501
            fencer_initial_timeout (int): [optional]  # noqa: E501
            fencer_max_timeout (int): [optional]  # noqa: E501
            fencer_multiplier_timeout (int): [optional]  # noqa: E501
            fencer_set_to_failed_after_timeout (bool): [optional]  # noqa: E501
            min_records_to_backup (int): [optional]  # noqa: E501
            backup_directory_capacity (int): [optional]  # noqa: E501
            backup_directory_warning (int): [optional]  # noqa: E501
            required_days_to_clear_archives (int): [optional]  # noqa: E501
            clear_archives_enabled (bool): [optional]  # noqa: E501
            version (str): [optional]  # noqa: E501
            auto_sync_network (bool): [optional]  # noqa: E501
            auto_scan_storages (bool): [optional]  # noqa: E501
            ntp_servers ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            cpu_topology ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
            default_name_pattern (str): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
