"""
    Controller API

    Controller description  # noqa: E501

    The version of the OpenAPI document: 6.x.x
    Contact: support@spacevm.ru
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401
from typing import List, Dict

from spacevm_controller_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from spacevm_controller_client.exceptions import ApiAttributeError


def lazy_import():
    from spacevm_controller_client.model.clipboard_copypaste_enum import ClipboardCopypasteEnum
    from spacevm_controller_client.model.filetransfer_enable_enum import FiletransferEnableEnum
    from spacevm_controller_client.model.image_compression_enum import ImageCompressionEnum
    from spacevm_controller_client.model.jpeg_compression_enum import JpegCompressionEnum
    from spacevm_controller_client.model.mouse_mode_enum import MouseModeEnum
    from spacevm_controller_client.model.playback_compression_enum import PlaybackCompressionEnum
    from spacevm_controller_client.model.streaming_mode_enum import StreamingModeEnum
    from spacevm_controller_client.model.zlib_compression_enum import ZlibCompressionEnum
    globals()['ClipboardCopypasteEnum'] = ClipboardCopypasteEnum
    globals()['FiletransferEnableEnum'] = FiletransferEnableEnum
    globals()['ImageCompressionEnum'] = ImageCompressionEnum
    globals()['JpegCompressionEnum'] = JpegCompressionEnum
    globals()['MouseModeEnum'] = MouseModeEnum
    globals()['PlaybackCompressionEnum'] = PlaybackCompressionEnum
    globals()['StreamingModeEnum'] = StreamingModeEnum
    globals()['ZlibCompressionEnum'] = ZlibCompressionEnum


class UpdateGraphicsSettings(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'image_compression': (ImageCompressionEnum,),  # noqa: E501
            'jpeg_compression': (JpegCompressionEnum,),  # noqa: E501
            'zlib_compression': (ZlibCompressionEnum,),  # noqa: E501
            'playback_compression': (PlaybackCompressionEnum,),  # noqa: E501
            'streaming_mode': (StreamingModeEnum,),  # noqa: E501
            'clipboard_copypaste': (ClipboardCopypasteEnum,),  # noqa: E501
            'filetransfer_enable': (FiletransferEnableEnum,),  # noqa: E501
            'mouse_mode': (MouseModeEnum,),  # noqa: E501
            'render': (str,),  # noqa: E501
            'simultaneous_clients': (bool,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'image_compression': 'image_compression',  # noqa: E501
        'jpeg_compression': 'jpeg_compression',  # noqa: E501
        'zlib_compression': 'zlib_compression',  # noqa: E501
        'playback_compression': 'playback_compression',  # noqa: E501
        'streaming_mode': 'streaming_mode',  # noqa: E501
        'clipboard_copypaste': 'clipboard_copypaste',  # noqa: E501
        'filetransfer_enable': 'filetransfer_enable',  # noqa: E501
        'mouse_mode': 'mouse_mode',  # noqa: E501
        'render': 'render',  # noqa: E501
        'simultaneous_clients': 'simultaneous_clients',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """UpdateGraphicsSettings - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            image_compression (ImageCompressionEnum): [optional]  # noqa: E501
            jpeg_compression (JpegCompressionEnum): [optional]  # noqa: E501
            zlib_compression (ZlibCompressionEnum): [optional]  # noqa: E501
            playback_compression (PlaybackCompressionEnum): [optional]  # noqa: E501
            streaming_mode (StreamingModeEnum): [optional]  # noqa: E501
            clipboard_copypaste (ClipboardCopypasteEnum): [optional]  # noqa: E501
            filetransfer_enable (FiletransferEnableEnum): [optional]  # noqa: E501
            mouse_mode (MouseModeEnum): [optional]  # noqa: E501
            render (str): PCI адрес устройства GL рендеринга из /dev/dri/by-path/pci-<ADDR>-render. [optional]  # noqa: E501
            simultaneous_clients (bool): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """UpdateGraphicsSettings - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            image_compression (ImageCompressionEnum): [optional]  # noqa: E501
            jpeg_compression (JpegCompressionEnum): [optional]  # noqa: E501
            zlib_compression (ZlibCompressionEnum): [optional]  # noqa: E501
            playback_compression (PlaybackCompressionEnum): [optional]  # noqa: E501
            streaming_mode (StreamingModeEnum): [optional]  # noqa: E501
            clipboard_copypaste (ClipboardCopypasteEnum): [optional]  # noqa: E501
            filetransfer_enable (FiletransferEnableEnum): [optional]  # noqa: E501
            mouse_mode (MouseModeEnum): [optional]  # noqa: E501
            render (str): PCI адрес устройства GL рендеринга из /dev/dri/by-path/pci-<ADDR>-render. [optional]  # noqa: E501
            simultaneous_clients (bool): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
