"""
    Controller API

    Controller description  # noqa: E501

    The version of the OpenAPI document: 6.x.x
    Contact: support@spacevm.ru
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401
from typing import List, Dict

from spacevm_controller_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from spacevm_controller_client.exceptions import ApiAttributeError


def lazy_import():
    from spacevm_controller_client.model.name_owner import NameOwner
    globals()['NameOwner'] = NameOwner


class VNetworkObject(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('verbose_name',): {
            'max_length': 255,
        },
        ('data_vni',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('description',): {
            'max_length': 255,
        },
        ('data_subnet',): {
            'max_length': 18,
        },
        ('data_vlan',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('data_mtu',): {
            'inclusive_maximum': 2147483647,
            'inclusive_minimum': -2147483648,
        },
        ('status',): {
            'max_length': 20,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'id': (str,),  # noqa: E501
            'verbose_name': (str,),  # noqa: E501
            'modified': (datetime,),  # noqa: E501
            'created': (datetime,),  # noqa: E501
            'permissions': (bool, date, datetime, dict, float, int, list, str, none_type,),  # noqa: E501
            'data_vni': (int,),  # noqa: E501
            'linked_lswitch_info': (str,),  # noqa: E501
            'linked_vswitch_info': (str,),  # noqa: E501
            'related_control_plane': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'vnservices': (str,),  # noqa: E501
            'entity_type': (str,),  # noqa: E501
            'port_group': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}, none_type,),  # noqa: E501
            'netflow_config': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'uplinks': ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}],),  # noqa: E501
            'connected_nodes': ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}],),  # noqa: E501
            'lswitch': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'tags': ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}],),  # noqa: E501
            'vnservices_info': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'address_pools': ([bool, date, datetime, dict, float, int, list, str, none_type],),  # noqa: E501
            'owners': ([NameOwner],),  # noqa: E501
            'related_access_policy': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
            'applied': (bool,),  # noqa: E501
            'related_external_network': (str,),  # noqa: E501
            'description': (str,),  # noqa: E501
            'locked_by': (str, none_type,),  # noqa: E501
            'data_subnet': (str, none_type,),  # noqa: E501
            'data_vlan': (int, none_type,),  # noqa: E501
            'data_mtu': (int,),  # noqa: E501
            'data_use_nat': (bool,),  # noqa: E501
            'status': (str,),  # noqa: E501
            'management': (bool,),  # noqa: E501
            'access_policy': (str, none_type,),  # noqa: E501
            'acl': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'verbose_name': 'verbose_name',  # noqa: E501
        'modified': 'modified',  # noqa: E501
        'created': 'created',  # noqa: E501
        'permissions': 'permissions',  # noqa: E501
        'data_vni': 'data_vni',  # noqa: E501
        'linked_lswitch_info': 'linked_lswitch_info',  # noqa: E501
        'linked_vswitch_info': 'linked_vswitch_info',  # noqa: E501
        'related_control_plane': 'related_control_plane',  # noqa: E501
        'vnservices': 'vnservices',  # noqa: E501
        'entity_type': 'entity_type',  # noqa: E501
        'port_group': 'port_group',  # noqa: E501
        'netflow_config': 'netflow_config',  # noqa: E501
        'uplinks': 'uplinks',  # noqa: E501
        'connected_nodes': 'connected_nodes',  # noqa: E501
        'lswitch': 'lswitch',  # noqa: E501
        'tags': 'tags',  # noqa: E501
        'vnservices_info': 'vnservices_info',  # noqa: E501
        'address_pools': 'address_pools',  # noqa: E501
        'owners': 'owners',  # noqa: E501
        'related_access_policy': 'related_access_policy',  # noqa: E501
        'applied': 'applied',  # noqa: E501
        'related_external_network': 'related_external_network',  # noqa: E501
        'description': 'description',  # noqa: E501
        'locked_by': 'locked_by',  # noqa: E501
        'data_subnet': 'data_subnet',  # noqa: E501
        'data_vlan': 'data_vlan',  # noqa: E501
        'data_mtu': 'data_mtu',  # noqa: E501
        'data_use_nat': 'data_use_nat',  # noqa: E501
        'status': 'status',  # noqa: E501
        'management': 'management',  # noqa: E501
        'access_policy': 'access_policy',  # noqa: E501
        'acl': 'acl',  # noqa: E501
    }

    read_only_vars = {
        'id',  # noqa: E501
        'modified',  # noqa: E501
        'created',  # noqa: E501
        'permissions',  # noqa: E501
        'linked_lswitch_info',  # noqa: E501
        'linked_vswitch_info',  # noqa: E501
        'related_control_plane',  # noqa: E501
        'entity_type',  # noqa: E501
        'port_group',  # noqa: E501
        'netflow_config',  # noqa: E501
        'uplinks',  # noqa: E501
        'connected_nodes',  # noqa: E501
        'lswitch',  # noqa: E501
        'tags',  # noqa: E501
        'vnservices_info',  # noqa: E501
        'address_pools',  # noqa: E501
        'owners',  # noqa: E501
        'related_access_policy',  # noqa: E501
        'applied',  # noqa: E501
        'related_external_network',  # noqa: E501
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, id, verbose_name, modified, created, permissions, data_vni, linked_lswitch_info, linked_vswitch_info, related_control_plane, vnservices, entity_type, port_group, netflow_config, uplinks, connected_nodes, lswitch, tags, vnservices_info, address_pools, owners, related_access_policy, applied, related_external_network, *args, **kwargs):  # noqa: E501
        """VNetworkObject - a model defined in OpenAPI

        Args:
            id (str):
            verbose_name (str):
            modified (datetime):
            created (datetime):
            permissions (bool, date, datetime, dict, float, int, list, str, none_type): Список разрешенных действий с моделью для текущего пользователя.
            data_vni (int):
            linked_lswitch_info (str):
            linked_vswitch_info (str):
            related_control_plane ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            vnservices (str):
            entity_type (str):
            port_group ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}, none_type):
            netflow_config ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            uplinks ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]):
            connected_nodes ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]):
            lswitch ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            tags ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]):
            vnservices_info ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            address_pools ([bool, date, datetime, dict, float, int, list, str, none_type]):
            owners ([NameOwner]):
            related_access_policy ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}):
            applied (bool):
            related_external_network (str):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            description (str): [optional]  # noqa: E501
            locked_by (str, none_type): [optional]  # noqa: E501
            data_subnet (str, none_type): [optional]  # noqa: E501
            data_vlan (int, none_type): [optional]  # noqa: E501
            data_mtu (int): [optional]  # noqa: E501
            data_use_nat (bool): [optional]  # noqa: E501
            status (str): [optional]  # noqa: E501
            management (bool): [optional]  # noqa: E501
            access_policy (str, none_type): [optional]  # noqa: E501
            acl ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.id = id
        self.verbose_name = verbose_name
        self.modified = modified
        self.created = created
        self.permissions = permissions
        self.data_vni = data_vni
        self.linked_lswitch_info = linked_lswitch_info
        self.linked_vswitch_info = linked_vswitch_info
        self.related_control_plane = related_control_plane
        self.vnservices = vnservices
        self.entity_type = entity_type
        self.port_group = port_group
        self.netflow_config = netflow_config
        self.uplinks = uplinks
        self.connected_nodes = connected_nodes
        self.lswitch = lswitch
        self.tags = tags
        self.vnservices_info = vnservices_info
        self.address_pools = address_pools
        self.owners = owners
        self.related_access_policy = related_access_policy
        self.applied = applied
        self.related_external_network = related_external_network
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, verbose_name, data_vni, vnservices, *args, **kwargs):  # noqa: E501
        """VNetworkObject - a model defined in OpenAPI

            verbose_name (str):
            data_vni (int):
            vnservices (str):
        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            description (str): [optional]  # noqa: E501
            locked_by (str, none_type): [optional]  # noqa: E501
            data_subnet (str, none_type): [optional]  # noqa: E501
            data_vlan (int, none_type): [optional]  # noqa: E501
            data_mtu (int): [optional]  # noqa: E501
            data_use_nat (bool): [optional]  # noqa: E501
            status (str): [optional]  # noqa: E501
            management (bool): [optional]  # noqa: E501
            access_policy (str, none_type): [optional]  # noqa: E501
            acl ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.verbose_name = verbose_name
        self.data_vni = data_vni
        self.vnservices = vnservices
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
