"""
    Controller API

    Controller description  # noqa: E501

    The version of the OpenAPI document: 6.x.x
    Contact: support@spacevm.ru
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401
from typing import List, Dict

from spacevm_controller_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from spacevm_controller_client.exceptions import ApiAttributeError


def lazy_import():
    from spacevm_controller_client.model.v_network_endpoint import VNetworkEndpoint
    from spacevm_controller_client.model.vn_services_instance_dhcp_option import VNServicesInstanceDhcpOption
    globals()['VNServicesInstanceDhcpOption'] = VNServicesInstanceDhcpOption
    globals()['VNetworkEndpoint'] = VNetworkEndpoint


class VnetworkWizard(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('verbose_name',): {
            'max_length': 255,
            'min_length': 3,
        },
        ('data_subnet',): {
            'max_length': 31,
            'min_length': 9,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'description': (str,),  # noqa: E501
            'data_vlan': (int,),  # noqa: E501
            'data_vni': (int,),  # noqa: E501
            'endpoints': ([VNetworkEndpoint],),  # noqa: E501
            'verbose_name': (str,),  # noqa: E501
            'data_mtu': (int,),  # noqa: E501
            'management': (bool,),  # noqa: E501
            'use_mgmt_interfaces': (bool,),  # noqa: E501
            'create_vnservices': (bool,),  # noqa: E501
            'data_subnet': (str,),  # noqa: E501
            'memory_limit': (int,),  # noqa: E501
            'vnservice_infs_params': ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}],),  # noqa: E501
            'data_use_nat': (bool,),  # noqa: E501
            'rule_nat_masquerade': (bool,),  # noqa: E501
            'access_policy': (str,),  # noqa: E501
            'control_plane': (str,),  # noqa: E501
            'firewall_autostart': (bool,),  # noqa: E501
            'dhcp_pools': ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}],),  # noqa: E501
            'dhcp_options': ([VNServicesInstanceDhcpOption],),  # noqa: E501
            'dhcp_reservations': ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}],),  # noqa: E501
            'dhcp_lease_lifetime': (int,),  # noqa: E501
            'dhcp_autostart': (bool,),  # noqa: E501
            'vswitch': (str,),  # noqa: E501
            'extnet': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'description': 'description',  # noqa: E501
        'data_vlan': 'data_vlan',  # noqa: E501
        'data_vni': 'data_vni',  # noqa: E501
        'endpoints': 'endpoints',  # noqa: E501
        'verbose_name': 'verbose_name',  # noqa: E501
        'data_mtu': 'data_mtu',  # noqa: E501
        'management': 'management',  # noqa: E501
        'use_mgmt_interfaces': 'use_mgmt_interfaces',  # noqa: E501
        'create_vnservices': 'create_vnservices',  # noqa: E501
        'data_subnet': 'data_subnet',  # noqa: E501
        'memory_limit': 'memory_limit',  # noqa: E501
        'vnservice_infs_params': 'vnservice_infs_params',  # noqa: E501
        'data_use_nat': 'data_use_nat',  # noqa: E501
        'rule_nat_masquerade': 'rule_nat_masquerade',  # noqa: E501
        'access_policy': 'access_policy',  # noqa: E501
        'control_plane': 'control_plane',  # noqa: E501
        'firewall_autostart': 'firewall_autostart',  # noqa: E501
        'dhcp_pools': 'dhcp_pools',  # noqa: E501
        'dhcp_options': 'dhcp_options',  # noqa: E501
        'dhcp_reservations': 'dhcp_reservations',  # noqa: E501
        'dhcp_lease_lifetime': 'dhcp_lease_lifetime',  # noqa: E501
        'dhcp_autostart': 'dhcp_autostart',  # noqa: E501
        'vswitch': 'vswitch',  # noqa: E501
        'extnet': 'extnet',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, description, data_vlan, data_vni, endpoints, *args, **kwargs):  # noqa: E501
        """VnetworkWizard - a model defined in OpenAPI

        Args:
            description (str): Краткое описание экземпляра.
            data_vlan (int): Значение идентификатора виртуальной сети VLAN.
            data_vni (int): Значение идентификатора виртуальной сети.
            endpoints ([VNetworkEndpoint]): List of endpoints that used to create L2 tunnels between nodes, included to virtual network.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            verbose_name (str): Уникальное удобочитаемое имя экземпляра.. [optional]  # noqa: E501
            data_mtu (int): Значение mtu виртуальной сети.. [optional] if omitted the server will use the default value of 1500  # noqa: E501
            management (bool): Flag determining whether virtual network be the management network or not. [optional] if omitted the server will use the default value of False  # noqa: E501
            use_mgmt_interfaces (bool): Flag determining whether to use management interfaces as L2 tunnel endpoints.. [optional] if omitted the server will use the default value of True  # noqa: E501
            create_vnservices (bool): Флаг, определяющий, создавать ли виртуальные сетевые сервисы.. [optional] if omitted the server will use the default value of False  # noqa: E501
            data_subnet (str): Адрес подсети, назначенный виртуальной сети.. [optional]  # noqa: E501
            memory_limit (int): Лимит памяти.. [optional]  # noqa: E501
            vnservice_infs_params ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]): Базовая конфигурация виртуальных сетевых сервисных интерфейсов.. [optional]  # noqa: E501
            data_use_nat (bool): [optional]  # noqa: E501
            rule_nat_masquerade (bool): [optional]  # noqa: E501
            access_policy (str): [optional]  # noqa: E501
            control_plane (str): [optional]  # noqa: E501
            firewall_autostart (bool): [optional]  # noqa: E501
            dhcp_pools ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]): Список словарей, содержащих первый и последний IP-адрес пула адресов DHCP.. [optional]  # noqa: E501
            dhcp_options ([VNServicesInstanceDhcpOption]): Список словарей, содержащих параметры DHCP.. [optional]  # noqa: E501
            dhcp_reservations ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]): Список словарей, содержащих адреса резервирования.. [optional]  # noqa: E501
            dhcp_lease_lifetime (int): [optional] if omitted the server will use the default value of 86400  # noqa: E501
            dhcp_autostart (bool): [optional]  # noqa: E501
            vswitch (str): UUID целевого виртуального коммутатора.. [optional]  # noqa: E501
            extnet (str): UUID целевой внешней сети.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.description = description
        self.data_vlan = data_vlan
        self.data_vni = data_vni
        self.endpoints = endpoints
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, description, data_vlan, data_vni, endpoints, *args, **kwargs):  # noqa: E501
        """VnetworkWizard - a model defined in OpenAPI

        Args:
            description (str): Краткое описание экземпляра.
            data_vlan (int): Значение идентификатора виртуальной сети VLAN.
            data_vni (int): Значение идентификатора виртуальной сети.
            endpoints ([VNetworkEndpoint]): List of endpoints that used to create L2 tunnels between nodes, included to virtual network.

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            verbose_name (str): Уникальное удобочитаемое имя экземпляра.. [optional]  # noqa: E501
            data_mtu (int): Значение mtu виртуальной сети.. [optional] if omitted the server will use the default value of 1500  # noqa: E501
            management (bool): Flag determining whether virtual network be the management network or not. [optional] if omitted the server will use the default value of False  # noqa: E501
            use_mgmt_interfaces (bool): Flag determining whether to use management interfaces as L2 tunnel endpoints.. [optional] if omitted the server will use the default value of True  # noqa: E501
            create_vnservices (bool): Флаг, определяющий, создавать ли виртуальные сетевые сервисы.. [optional] if omitted the server will use the default value of False  # noqa: E501
            data_subnet (str): Адрес подсети, назначенный виртуальной сети.. [optional]  # noqa: E501
            memory_limit (int): Лимит памяти.. [optional]  # noqa: E501
            vnservice_infs_params ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]): Базовая конфигурация виртуальных сетевых сервисных интерфейсов.. [optional]  # noqa: E501
            data_use_nat (bool): [optional]  # noqa: E501
            rule_nat_masquerade (bool): [optional]  # noqa: E501
            access_policy (str): [optional]  # noqa: E501
            control_plane (str): [optional]  # noqa: E501
            firewall_autostart (bool): [optional]  # noqa: E501
            dhcp_pools ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]): Список словарей, содержащих первый и последний IP-адрес пула адресов DHCP.. [optional]  # noqa: E501
            dhcp_options ([VNServicesInstanceDhcpOption]): Список словарей, содержащих параметры DHCP.. [optional]  # noqa: E501
            dhcp_reservations ([{str: (bool, date, datetime, dict, float, int, list, str, none_type)}]): Список словарей, содержащих адреса резервирования.. [optional]  # noqa: E501
            dhcp_lease_lifetime (int): [optional] if omitted the server will use the default value of 86400  # noqa: E501
            dhcp_autostart (bool): [optional]  # noqa: E501
            vswitch (str): UUID целевого виртуального коммутатора.. [optional]  # noqa: E501
            extnet (str): UUID целевой внешней сети.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.description = description
        self.data_vlan = data_vlan
        self.data_vni = data_vni
        self.endpoints = endpoints
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
