"""
(c) 2023 «Dacom M» Ltd
"""

from veilrpc.utils.bazalt import states_response, CommandExecutionError, get_output


@states_response
def mkfs(fs_type, device, options):
    if fs_type == 'ocfs2':
        cmd = f'echo "y" | mkfs -t {fs_type} -F {device} {options}'
    elif fs_type == 'gfs2':
        cmd = f'mkfs -t {fs_type} -O -p lock_dlm {device} {options}'
    else:
        raise CommandExecutionError('Not implemented')
    cmd_ret = get_output(cmd, timeout=86400)
    if not cmd_ret['result']:
        raise CommandExecutionError(cmd_ret['comment'])
    return f'Successfully build linux file system {fs_type} on block device {device}.'


@states_response
def tunegfs2(device, options):
    cmd = f'tunegfs2 {options} {device}'
    cmd_ret = get_output(cmd, timeout=86400)
    if not cmd_ret['result']:
        raise CommandExecutionError(cmd_ret['comment'])
    return get_output(f'tunegfs2 -l {device}', timeout=86400)['comment']
