"""
(c) 2023 «Dacom M» Ltd
"""

CPU_MODELS = {
    "AMD": {
        "EPYC": {
            "family": "23",
            "family_model": "1",
            "features": [
                "3dnowprefetch",
                "abm",
                "adx",
                "aes",
                "apic",
                "arat",
                "avx",
                "avx2",
                "bmi1",
                "bmi2",
                "clflush",
                "clflushopt",
                "cmov",
                "cr8legacy",
                "cx16",
                "cx8",
                "de",
                "f16c",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "fxsr_opt",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "misalignsse",
                "mmx",
                "mmxext",
                "monitor",
                "movbe",
                "msr",
                "mtrr",
                "nx",
                "osvw",
                "pae",
                "pat",
                "pclmuldq",
                "pdpe1gb",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdrand",
                "rdseed",
                "rdtscp",
                "sep",
                "sha-ni",
                "smap",
                "smep",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "sse4a",
                "ssse3",
                "svm",
                "syscall",
                "tsc",
                "vme",
                "xgetbv1",
                "xsave",
                "xsavec",
                "xsaveopt"
            ]
        },
        "EPYC-IBPB": {
            "family": "23",
            "family_model": "1",
            "features": [
                "3dnowprefetch",
                "abm",
                "adx",
                "aes",
                "apic",
                "arat",
                "avx",
                "avx2",
                "bmi1",
                "bmi2",
                "clflush",
                "clflushopt",
                "cmov",
                "cr8legacy",
                "cx16",
                "cx8",
                "de",
                "f16c",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "fxsr_opt",
                "ibpb",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "misalignsse",
                "mmx",
                "mmxext",
                "monitor",
                "movbe",
                "msr",
                "mtrr",
                "nx",
                "osvw",
                "pae",
                "pat",
                "pclmuldq",
                "pdpe1gb",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdrand",
                "rdseed",
                "rdtscp",
                "sep",
                "sha-ni",
                "smap",
                "smep",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "sse4a",
                "ssse3",
                "svm",
                "syscall",
                "tsc",
                "vme",
                "xgetbv1",
                "xsave",
                "xsavec",
                "xsaveopt"
            ]
        },
        "EPYC-Milan": {
            "family": "25",
            "family_model": "1",
            "features": [
                "3dnowprefetch",
                "abm",
                "adx",
                "aes",
                "amd-ssbd",
                "amd-stibp",
                "apic",
                "arat",
                "avx",
                "avx2",
                "bmi1",
                "bmi2",
                "clflush",
                "clflushopt",
                "clwb",
                "clzero",
                "cmov",
                "cr8legacy",
                "cx16",
                "cx8",
                "de",
                "erms",
                "f16c",
                "fma",
                "fpu",
                "fsgsbase",
                "fsrm",
                "fxsr",
                "fxsr_opt",
                "ibpb",
                "ibrs",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "misalignsse",
                "mmx",
                "mmxext",
                "movbe",
                "msr",
                "mtrr",
                "npt",
                "nrip-save",
                "nx",
                "osvw",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pdpe1gb",
                "perfctr_core",
                "pge",
                "pku",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdpid",
                "rdrand",
                "rdseed",
                "rdtscp",
                "sep",
                "sha-ni",
                "smap",
                "smep",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "sse4a",
                "ssse3",
                "svm",
                "svme-addr-chk",
                "syscall",
                "tsc",
                "umip",
                "vme",
                "wbnoinvd",
                "xgetbv1",
                "xsave",
                "xsavec",
                "xsaveerptr",
                "xsaveopt",
                "xsaves"
            ]
        },
        "EPYC-Rome": {
            "family": "23",
            "family_model": "49",
            "features": [
                "3dnowprefetch",
                "abm",
                "adx",
                "aes",
                "amd-stibp",
                "apic",
                "arat",
                "avx",
                "avx2",
                "bmi1",
                "bmi2",
                "clflush",
                "clflushopt",
                "clwb",
                "clzero",
                "cmov",
                "cr8legacy",
                "cx16",
                "cx8",
                "de",
                "f16c",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "fxsr_opt",
                "ibpb",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "misalignsse",
                "mmx",
                "mmxext",
                "movbe",
                "msr",
                "mtrr",
                "npt",
                "nrip-save",
                "nx",
                "osvw",
                "pae",
                "pat",
                "pclmuldq",
                "pdpe1gb",
                "perfctr_core",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdpid",
                "rdrand",
                "rdseed",
                "rdtscp",
                "sep",
                "sha-ni",
                "smap",
                "smep",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "sse4a",
                "ssse3",
                "svm",
                "syscall",
                "tsc",
                "umip",
                "vme",
                "wbnoinvd",
                "xgetbv1",
                "xsave",
                "xsavec",
                "xsaveerptr",
                "xsaveopt"
            ]
        },
        "Opteron_G1": {
            "family": "15",
            "family_model": "6",
            "features": [
                "apic",
                "clflush",
                "cmov",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "lm",
                "mca",
                "mce",
                "mmx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pge",
                "pni",
                "pse",
                "pse36",
                "sep",
                "sse",
                "sse2",
                "syscall",
                "tsc"
            ]
        },
        "Opteron_G2": {
            "family": "15",
            "family_model": "6",
            "features": [
                "apic",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pge",
                "pni",
                "pse",
                "pse36",
                "rdtscp",
                "sep",
                "sse",
                "sse2",
                "svm",
                "syscall",
                "tsc"
            ]
        },
        "Opteron_G3": {
            "family": "15",
            "family_model": "6",
            "features": [
                "abm",
                "apic",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "misalignsse",
                "mmx",
                "monitor",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdtscp",
                "sep",
                "sse",
                "sse2",
                "sse4a",
                "svm",
                "syscall",
                "tsc"
            ]
        },
        "Opteron_G4": {
            "family": "21",
            "family_model": "1",
            "features": [
                "3dnowprefetch",
                "abm",
                "aes",
                "apic",
                "avx",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "fma4",
                "fpu",
                "fxsr",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "misalignsse",
                "mmx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pclmuldq",
                "pdpe1gb",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdtscp",
                "sep",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "sse4a",
                "ssse3",
                "svm",
                "syscall",
                "tsc",
                "xop",
                "xsave"
            ]
        },
        "Opteron_G5": {
            "family": "21",
            "family_model": "2",
            "features": [
                "3dnowprefetch",
                "abm",
                "aes",
                "apic",
                "avx",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "f16c",
                "fma",
                "fma4",
                "fpu",
                "fxsr",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "misalignsse",
                "mmx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pclmuldq",
                "pdpe1gb",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdtscp",
                "sep",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "sse4a",
                "ssse3",
                "svm",
                "syscall",
                "tbm",
                "tsc",
                "xop",
                "xsave"
            ]
        },
        "athlon": {
            "family": "Unknown",
            "family_model": "Unknown",
            "features": [
                "3dnow",
                "3dnowext",
                "apic",
                "cmov",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "mce",
                "mmx",
                "mmxext",
                "msr",
                "mtrr",
                "pae",
                "pat",
                "pge",
                "pse",
                "pse36",
                "sep",
                "sse",
                "sse2",
                "tsc",
                "vme"
            ]
        },
        "phenom": {
            "family": "Unknown",
            "family_model": "Unknown",
            "features": [
                "3dnow",
                "3dnowext",
                "apic",
                "clflush",
                "cmov",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "fxsr_opt",
                "lm",
                "mca",
                "mce",
                "mmx",
                "mmxext",
                "monitor",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pge",
                "pni",
                "pse",
                "pse36",
                "sep",
                "sse",
                "sse2",
                "svm",
                "syscall",
                "tsc"
            ]
        }
    },
    "Hygon": {
        "Dhyana": {
            "family": "24",
            "family_model": "0",
            "features": [
                "3dnowprefetch",
                "abm",
                "adx",
                "apic",
                "arat",
                "avx",
                "avx2",
                "bmi1",
                "bmi2",
                "clflush",
                "clflushopt",
                "cmov",
                "cr8legacy",
                "cx16",
                "cx8",
                "de",
                "f16c",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "fxsr_opt",
                "ibpb",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "misalignsse",
                "mmx",
                "mmxext",
                "monitor",
                "movbe",
                "msr",
                "mtrr",
                "nx",
                "osvw",
                "pae",
                "pat",
                "pdpe1gb",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdrand",
                "rdseed",
                "rdtscp",
                "sep",
                "smap",
                "smep",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "sse4a",
                "ssse3",
                "svm",
                "syscall",
                "tsc",
                "vme",
                "xgetbv1",
                "xsave",
                "xsavec",
                "xsaveopt"
            ]
        }
    },
    "Intel": {
        "Broadwell": {
            "family": "6",
            "family_model": "61",
            "features": [
                "3dnowprefetch",
                "adx",
                "aes",
                "apic",
                "avx",
                "avx2",
                "bmi1",
                "bmi2",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "hle",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdseed",
                "rdtscp",
                "rtm",
                "sep",
                "smap",
                "smep",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "x2apic",
                "xsave"
            ]
        },
        "Broadwell-IBRS": {
            "family": "6",
            "family_model": "61",
            "features": [
                "3dnowprefetch",
                "adx",
                "aes",
                "apic",
                "avx",
                "avx2",
                "bmi1",
                "bmi2",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "hle",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdseed",
                "rdtscp",
                "rtm",
                "sep",
                "smap",
                "smep",
                "spec-ctrl",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "x2apic",
                "xsave"
            ]
        },
        "Broadwell-noTSX": {
            "family": "6",
            "family_model": "61",
            "features": [
                "3dnowprefetch",
                "adx",
                "aes",
                "apic",
                "avx",
                "avx2",
                "bmi1",
                "bmi2",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdseed",
                "rdtscp",
                "sep",
                "smap",
                "smep",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "x2apic",
                "xsave"
            ]
        },
        "Broadwell-noTSX-IBRS": {
            "family": "6",
            "family_model": "61",
            "features": [
                "3dnowprefetch",
                "adx",
                "aes",
                "apic",
                "avx",
                "avx2",
                "bmi1",
                "bmi2",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdseed",
                "rdtscp",
                "sep",
                "smap",
                "smep",
                "spec-ctrl",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "x2apic",
                "xsave"
            ]
        },
        "Cascadelake-Server": {
            "family": "6",
            "family_model": "85",
            "features": [
                "3dnowprefetch",
                "abm",
                "adx",
                "aes",
                "apic",
                "arat",
                "avx",
                "avx2",
                "avx512bw",
                "avx512cd",
                "avx512dq",
                "avx512f",
                "avx512vl",
                "avx512vnni",
                "bmi1",
                "bmi2",
                "clflush",
                "clflushopt",
                "clwb",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "f16c",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "hle",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "mpx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pdpe1gb",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdrand",
                "rdseed",
                "rdtscp",
                "rtm",
                "sep",
                "smap",
                "smep",
                "spec-ctrl",
                "ssbd",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "vme",
                "x2apic",
                "xgetbv1",
                "xsave",
                "xsavec",
                "xsaveopt"
            ]
        },
        "Cascadelake-Server-noTSX": {
            "family": "6",
            "family_model": "85",
            "features": [
                "3dnowprefetch",
                "abm",
                "adx",
                "aes",
                "apic",
                "arat",
                "avx",
                "avx2",
                "avx512bw",
                "avx512cd",
                "avx512dq",
                "avx512f",
                "avx512vl",
                "avx512vnni",
                "bmi1",
                "bmi2",
                "clflush",
                "clflushopt",
                "clwb",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "f16c",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "mpx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pdpe1gb",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdrand",
                "rdseed",
                "rdtscp",
                "sep",
                "smap",
                "smep",
                "spec-ctrl",
                "ssbd",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "vme",
                "x2apic",
                "xgetbv1",
                "xsave",
                "xsavec",
                "xsaveopt"
            ]
        },
        "Conroe": {
            "family": "6",
            "family_model": "15",
            "features": [
                "apic",
                "clflush",
                "cmov",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pge",
                "pni",
                "pse",
                "pse36",
                "sep",
                "sse",
                "sse2",
                "ssse3",
                "syscall",
                "tsc"
            ]
        },
        "Cooperlake": {
            "family": "6",
            "family_model": "85",
            "features": [
                "3dnowprefetch",
                "abm",
                "adx",
                "aes",
                "apic",
                "arat",
                "arch-capabilities",
                "avx",
                "avx2",
                "avx512-bf16",
                "avx512bw",
                "avx512cd",
                "avx512dq",
                "avx512f",
                "avx512vl",
                "avx512vnni",
                "bmi1",
                "bmi2",
                "clflush",
                "clflushopt",
                "clwb",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "f16c",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "hle",
                "ibrs-all",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mds-no",
                "mmx",
                "movbe",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pdpe1gb",
                "pge",
                "pku",
                "pni",
                "popcnt",
                "pschange-mc-no",
                "pse",
                "pse36",
                "rdctl-no",
                "rdrand",
                "rdseed",
                "rdtscp",
                "rtm",
                "sep",
                "skip-l1dfl-vmentry",
                "smap",
                "smep",
                "spec-ctrl",
                "ssbd",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "stibp",
                "syscall",
                "taa-no",
                "tsc",
                "tsc-deadline",
                "vme",
                "x2apic",
                "xgetbv1",
                "xsave",
                "xsavec",
                "xsaveopt"
            ]
        },
        "Haswell": {
            "family": "6",
            "family_model": "60",
            "features": [
                "aes",
                "apic",
                "avx",
                "avx2",
                "bmi1",
                "bmi2",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "hle",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdtscp",
                "rtm",
                "sep",
                "smep",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "x2apic",
                "xsave"
            ]
        },
        "Haswell-IBRS": {
            "family": "6",
            "family_model": "60",
            "features": [
                "aes",
                "apic",
                "avx",
                "avx2",
                "bmi1",
                "bmi2",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "hle",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdtscp",
                "rtm",
                "sep",
                "smep",
                "spec-ctrl",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "x2apic",
                "xsave"
            ]
        },
        "Haswell-noTSX": {
            "family": "6",
            "family_model": "60",
            "features": [
                "aes",
                "apic",
                "avx",
                "avx2",
                "bmi1",
                "bmi2",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdtscp",
                "sep",
                "smep",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "x2apic",
                "xsave"
            ]
        },
        "Haswell-noTSX-IBRS": {
            "family": "6",
            "family_model": "60",
            "features": [
                "aes",
                "apic",
                "avx",
                "avx2",
                "bmi1",
                "bmi2",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdtscp",
                "sep",
                "smep",
                "spec-ctrl",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "x2apic",
                "xsave"
            ]
        },
        "Icelake-Client": {
            "family": "6",
            "family_model": "126",
            "features": [
                "3dnowprefetch",
                "abm",
                "adx",
                "aes",
                "apic",
                "arat",
                "avx",
                "avx2",
                "avx512-vpopcntdq",
                "avx512bitalg",
                "avx512vbmi",
                "avx512vbmi2",
                "avx512vnni",
                "bmi1",
                "bmi2",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "f16c",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "gfni",
                "hle",
                "intel-pt",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "mpx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pge",
                "pku",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdrand",
                "rdseed",
                "rdtscp",
                "rtm",
                "sep",
                "smap",
                "smep",
                "spec-ctrl",
                "ssbd",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "umip",
                "vaes",
                "vme",
                "vpclmulqdq",
                "wbnoinvd",
                "x2apic",
                "xgetbv1",
                "xsave",
                "xsavec",
                "xsaveopt"
            ]
        },
        "Icelake-Client-noTSX": {
            "family": "6",
            "family_model": "126",
            "features": [
                "3dnowprefetch",
                "abm",
                "adx",
                "aes",
                "apic",
                "arat",
                "avx",
                "avx2",
                "avx512-vpopcntdq",
                "avx512bitalg",
                "avx512vbmi",
                "avx512vbmi2",
                "avx512vnni",
                "bmi1",
                "bmi2",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "f16c",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "gfni",
                "intel-pt",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "mpx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pge",
                "pku",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdrand",
                "rdseed",
                "rdtscp",
                "sep",
                "smap",
                "smep",
                "spec-ctrl",
                "ssbd",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "umip",
                "vaes",
                "vme",
                "vpclmulqdq",
                "wbnoinvd",
                "x2apic",
                "xgetbv1",
                "xsave",
                "xsavec",
                "xsaveopt"
            ]
        },
        "Icelake-Server": {
            "family": "6",
            "family_model": "106",
            "features": [
                "3dnowprefetch",
                "abm",
                "adx",
                "aes",
                "apic",
                "arat",
                "avx",
                "avx2",
                "avx512-vpopcntdq",
                "avx512bitalg",
                "avx512bw",
                "avx512cd",
                "avx512dq",
                "avx512f",
                "avx512vbmi",
                "avx512vbmi2",
                "avx512vl",
                "avx512vnni",
                "bmi1",
                "bmi2",
                "clflush",
                "clflushopt",
                "clwb",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "f16c",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "gfni",
                "hle",
                "intel-pt",
                "invpcid",
                "la57",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "mpx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pdpe1gb",
                "pge",
                "pku",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdrand",
                "rdseed",
                "rdtscp",
                "rtm",
                "sep",
                "smap",
                "smep",
                "spec-ctrl",
                "ssbd",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "umip",
                "vaes",
                "vme",
                "vpclmulqdq",
                "wbnoinvd",
                "x2apic",
                "xgetbv1",
                "xsave",
                "xsavec",
                "xsaveopt"
            ]
        },
        "Icelake-Server-noTSX": {
            "family": "6",
            "family_model": "106",
            "features": [
                "3dnowprefetch",
                "abm",
                "adx",
                "aes",
                "apic",
                "arat",
                "avx",
                "avx2",
                "avx512-vpopcntdq",
                "avx512bitalg",
                "avx512bw",
                "avx512cd",
                "avx512dq",
                "avx512f",
                "avx512vbmi",
                "avx512vbmi2",
                "avx512vl",
                "avx512vnni",
                "bmi1",
                "bmi2",
                "clflush",
                "clflushopt",
                "clwb",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "f16c",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "gfni",
                "intel-pt",
                "invpcid",
                "la57",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "mpx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pdpe1gb",
                "pge",
                "pku",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdrand",
                "rdseed",
                "rdtscp",
                "sep",
                "smap",
                "smep",
                "spec-ctrl",
                "ssbd",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "umip",
                "vaes",
                "vme",
                "vpclmulqdq",
                "wbnoinvd",
                "x2apic",
                "xgetbv1",
                "xsave",
                "xsavec",
                "xsaveopt"
            ]
        },
        "IvyBridge": {
            "family": "6",
            "family_model": "58",
            "features": [
                "aes",
                "apic",
                "avx",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "f16c",
                "fpu",
                "fsgsbase",
                "fxsr",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pclmuldq",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdrand",
                "rdtscp",
                "sep",
                "smep",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "vme",
                "x2apic",
                "xsave"
            ]
        },
        "IvyBridge-IBRS": {
            "family": "6",
            "family_model": "58",
            "features": [
                "aes",
                "apic",
                "avx",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "f16c",
                "fpu",
                "fsgsbase",
                "fxsr",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pclmuldq",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdrand",
                "rdtscp",
                "sep",
                "smep",
                "spec-ctrl",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "vme",
                "x2apic",
                "xsave"
            ]
        },
        "Nehalem": {
            "family": "6",
            "family_model": "26",
            "features": [
                "apic",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "sep",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc"
            ]
        },
        "Nehalem-IBRS": {
            "family": "6",
            "family_model": "26",
            "features": [
                "apic",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "sep",
                "spec-ctrl",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc"
            ]
        },
        "Penryn": {
            "family": "6",
            "family_model": "23",
            "features": [
                "apic",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pge",
                "pni",
                "pse",
                "pse36",
                "sep",
                "sse",
                "sse2",
                "sse4.1",
                "ssse3",
                "syscall",
                "tsc"
            ]
        },
        "SandyBridge": {
            "family": "6",
            "family_model": "42",
            "features": [
                "aes",
                "apic",
                "avx",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pclmuldq",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdtscp",
                "sep",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "x2apic",
                "xsave"
            ]
        },
        "SandyBridge-IBRS": {
            "family": "6",
            "family_model": "42",
            "features": [
                "aes",
                "apic",
                "avx",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pclmuldq",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdtscp",
                "sep",
                "spec-ctrl",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "x2apic",
                "xsave"
            ]
        },
        "Skylake-Client": {
            "family": "6",
            "family_model": "94",
            "features": [
                "3dnowprefetch",
                "abm",
                "adx",
                "aes",
                "apic",
                "arat",
                "avx",
                "avx2",
                "bmi1",
                "bmi2",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "f16c",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "hle",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "mpx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdrand",
                "rdseed",
                "rdtscp",
                "rtm",
                "sep",
                "smap",
                "smep",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "vme",
                "x2apic",
                "xgetbv1",
                "xsave",
                "xsavec",
                "xsaveopt"
            ]
        },
        "Skylake-Client-IBRS": {
            "family": "6",
            "family_model": "94",
            "features": [
                "3dnowprefetch",
                "abm",
                "adx",
                "aes",
                "apic",
                "arat",
                "avx",
                "avx2",
                "bmi1",
                "bmi2",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "f16c",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "hle",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "mpx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdrand",
                "rdseed",
                "rdtscp",
                "rtm",
                "sep",
                "smap",
                "smep",
                "spec-ctrl",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "vme",
                "x2apic",
                "xgetbv1",
                "xsave",
                "xsavec",
                "xsaveopt"
            ]
        },
        "Skylake-Client-noTSX-IBRS": {
            "family": "6",
            "family_model": "94",
            "features": [
                "3dnowprefetch",
                "abm",
                "adx",
                "aes",
                "apic",
                "arat",
                "avx",
                "avx2",
                "bmi1",
                "bmi2",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "f16c",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "mpx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdrand",
                "rdseed",
                "rdtscp",
                "sep",
                "smap",
                "smep",
                "spec-ctrl",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "vme",
                "x2apic",
                "xgetbv1",
                "xsave",
                "xsavec",
                "xsaveopt"
            ]
        },
        "Skylake-Server": {
            "family": "6",
            "family_model": "85",
            "features": [
                "3dnowprefetch",
                "abm",
                "adx",
                "aes",
                "apic",
                "arat",
                "avx",
                "avx2",
                "avx512bw",
                "avx512cd",
                "avx512dq",
                "avx512f",
                "avx512vl",
                "bmi1",
                "bmi2",
                "clflush",
                "clwb",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "f16c",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "hle",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "mpx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pdpe1gb",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdrand",
                "rdseed",
                "rdtscp",
                "rtm",
                "sep",
                "smap",
                "smep",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "vme",
                "x2apic",
                "xgetbv1",
                "xsave",
                "xsavec",
                "xsaveopt"
            ]
        },
        "Skylake-Server-IBRS": {
            "family": "6",
            "family_model": "85",
            "features": [
                "3dnowprefetch",
                "abm",
                "adx",
                "aes",
                "apic",
                "arat",
                "avx",
                "avx2",
                "avx512bw",
                "avx512cd",
                "avx512dq",
                "avx512f",
                "avx512vl",
                "bmi1",
                "bmi2",
                "clflush",
                "clwb",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "f16c",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "hle",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "mpx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pdpe1gb",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdrand",
                "rdseed",
                "rdtscp",
                "rtm",
                "sep",
                "smap",
                "smep",
                "spec-ctrl",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "vme",
                "x2apic",
                "xgetbv1",
                "xsave",
                "xsavec",
                "xsaveopt"
            ]
        },
        "Skylake-Server-noTSX-IBRS": {
            "family": "6",
            "family_model": "85",
            "features": [
                "3dnowprefetch",
                "abm",
                "adx",
                "aes",
                "apic",
                "arat",
                "avx",
                "avx2",
                "avx512bw",
                "avx512cd",
                "avx512dq",
                "avx512f",
                "avx512vl",
                "bmi1",
                "bmi2",
                "clflush",
                "clwb",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "erms",
                "f16c",
                "fma",
                "fpu",
                "fsgsbase",
                "fxsr",
                "invpcid",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "mpx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pcid",
                "pclmuldq",
                "pdpe1gb",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdrand",
                "rdseed",
                "rdtscp",
                "sep",
                "smap",
                "smep",
                "spec-ctrl",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "vme",
                "x2apic",
                "xgetbv1",
                "xsave",
                "xsavec",
                "xsaveopt"
            ]
        },
        "Snowridge": {
            "family": "6",
            "family_model": "134",
            "features": [
                "3dnowprefetch",
                "aes",
                "apic",
                "arat",
                "arch-capabilities",
                "cldemote",
                "clflush",
                "clflushopt",
                "clwb",
                "cmov",
                "core-capability",
                "cx16",
                "cx8",
                "de",
                "erms",
                "fpu",
                "fsgsbase",
                "fxsr",
                "gfni",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "movbe",
                "movdir64b",
                "movdiri",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pclmuldq",
                "pdpe1gb",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "rdrand",
                "rdseed",
                "rdtscp",
                "sep",
                "sha-ni",
                "smap",
                "smep",
                "spec-ctrl",
                "split-lock-detect",
                "ssbd",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc",
                "tsc-deadline",
                "umip",
                "vme",
                "x2apic",
                "xgetbv1",
                "xsave",
                "xsavec",
                "xsaveopt"
            ]
        },
        "Westmere": {
            "family": "6",
            "family_model": "44",
            "features": [
                "aes",
                "apic",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "sep",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc"
            ]
        },
        "Westmere-IBRS": {
            "family": "6",
            "family_model": "44",
            "features": [
                "aes",
                "apic",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pge",
                "pni",
                "popcnt",
                "pse",
                "pse36",
                "sep",
                "spec-ctrl",
                "sse",
                "sse2",
                "sse4.1",
                "sse4.2",
                "ssse3",
                "syscall",
                "tsc"
            ]
        },
        "core2duo": {
            "family": "Unknown",
            "family_model": "Unknown",
            "features": [
                "apic",
                "clflush",
                "cmov",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "lm",
                "mca",
                "mce",
                "mmx",
                "monitor",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pge",
                "pni",
                "pse",
                "pse36",
                "sep",
                "sse",
                "sse2",
                "ssse3",
                "syscall",
                "tsc",
                "vme"
            ]
        },
        "coreduo": {
            "family": "Unknown",
            "family_model": "Unknown",
            "features": [
                "apic",
                "clflush",
                "cmov",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "mca",
                "mce",
                "mmx",
                "monitor",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pge",
                "pni",
                "pse",
                "sep",
                "sse",
                "sse2",
                "tsc",
                "vme"
            ]
        },
        "n270": {
            "family": "Unknown",
            "family_model": "Unknown",
            "features": [
                "apic",
                "clflush",
                "cmov",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "mca",
                "mce",
                "mmx",
                "monitor",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pge",
                "pni",
                "pse",
                "sep",
                "sse",
                "sse2",
                "ssse3",
                "tsc",
                "vme"
            ]
        }
    },
    "Other": {
        "486": {
            "family": "Unknown",
            "family_model": "Unknown",
            "features": [
                "fpu",
                "pse",
                "vme"
            ]
        },
        "cpu64-rhel5": {
            "family": "Unknown",
            "family_model": "Unknown",
            "features": [
                "apic",
                "clflush",
                "cmov",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "lm",
                "mca",
                "mce",
                "mmx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pge",
                "pni",
                "pse",
                "pse36",
                "sep",
                "sse",
                "sse2",
                "syscall",
                "tsc"
            ]
        },
        "cpu64-rhel6": {
            "family": "Unknown",
            "family_model": "Unknown",
            "features": [
                "apic",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "lahf_lm",
                "lm",
                "mca",
                "mce",
                "mmx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pge",
                "pni",
                "pse",
                "pse36",
                "sep",
                "sse",
                "sse2",
                "syscall",
                "tsc"
            ]
        },
        "kvm32": {
            "family": "Unknown",
            "family_model": "Unknown",
            "features": [
                "apic",
                "clflush",
                "cmov",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "mca",
                "mce",
                "mmx",
                "msr",
                "mtrr",
                "pae",
                "pat",
                "pge",
                "pni",
                "pse",
                "pse36",
                "sep",
                "sse",
                "sse2",
                "tsc"
            ]
        },
        "kvm64": {
            "family": "Unknown",
            "family_model": "Unknown",
            "features": [
                "apic",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "lm",
                "mca",
                "mce",
                "mmx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pge",
                "pni",
                "pse",
                "pse36",
                "sep",
                "sse",
                "sse2",
                "syscall",
                "tsc"
            ]
        },
        "pentium": {
            "family": "Unknown",
            "family_model": "Unknown",
            "features": [
                "cx8",
                "de",
                "fpu",
                "mce",
                "mmx",
                "msr",
                "pse",
                "tsc",
                "vme"
            ]
        },
        "pentium2": {
            "family": "Unknown",
            "family_model": "Unknown",
            "features": [
                "cmov",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "mca",
                "mce",
                "mmx",
                "msr",
                "mtrr",
                "pae",
                "pat",
                "pge",
                "pse",
                "pse36",
                "sep",
                "tsc",
                "vme"
            ]
        },
        "pentium3": {
            "family": "Unknown",
            "family_model": "Unknown",
            "features": [
                "cmov",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "mca",
                "mce",
                "mmx",
                "msr",
                "mtrr",
                "pae",
                "pat",
                "pge",
                "pse",
                "pse36",
                "sep",
                "sse",
                "tsc",
                "vme"
            ]
        },
        "pentiumpro": {
            "family": "Unknown",
            "family_model": "Unknown",
            "features": [
                "apic",
                "cmov",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "mce",
                "mmx",
                "msr",
                "pae",
                "pat",
                "pge",
                "pse",
                "sep",
                "sse",
                "sse2",
                "tsc"
            ]
        },
        "qemu32": {
            "family": "Unknown",
            "family_model": "Unknown",
            "features": [
                "apic",
                "cmov",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "mce",
                "mmx",
                "msr",
                "pae",
                "pat",
                "pge",
                "pni",
                "pse",
                "sep",
                "sse",
                "sse2",
                "tsc"
            ]
        },
        "qemu64": {
            "family": "Unknown",
            "family_model": "Unknown",
            "features": [
                "apic",
                "clflush",
                "cmov",
                "cx16",
                "cx8",
                "de",
                "fpu",
                "fxsr",
                "lm",
                "mca",
                "mce",
                "mmx",
                "msr",
                "mtrr",
                "nx",
                "pae",
                "pat",
                "pge",
                "pni",
                "pse",
                "pse36",
                "sep",
                "sse",
                "sse2",
                "syscall",
                "tsc"
            ]
        }
    }
}
